# IO.Swagger - the C# library for the 1Gb API

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- SDK version: 1.0.0
- Build date: 2016-11-03T11:50:21.350+04:00
- Build package: class io.swagger.codegen.languages.CSharpClientCodegen

## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

## Dependencies
- [RestSharp](https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET](https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later

The DLLs included in the package may not be the latest version. We recommned using [NuGet] (https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;
```

## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;

namespace Example
{
    public class Example
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Аккаунт: баланс
                decimal? result = apiInstance.BalanceGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BalanceGet: " + e.Message );
            }
        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to *https://www.1gb.ru/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**BalanceGet**](docs/DefaultApi.md#balanceget) | **GET** /balance | Аккаунт: баланс
*DefaultApi* | [**BalanceLicGet**](docs/DefaultApi.md#balancelicget) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
*DefaultApi* | [**BillingDebtGet**](docs/DefaultApi.md#billingdebtget) | **GET** /billing/debt | Информация по дебету аккаунта
*DefaultApi* | [**BillingInfoGet**](docs/DefaultApi.md#billinginfoget) | **GET** /billing/info | Информация об аккаунте
*DefaultApi* | [**BillingLimitsGet**](docs/DefaultApi.md#billinglimitsget) | **GET** /billing/limits | Получить ограничения аккаунта
*DefaultApi* | [**DnsProlongListGet**](docs/DefaultApi.md#dnsprolonglistget) | **GET** /dns/prolong/list | Информация по продлению доменов
*DefaultApi* | [**EmailAddGet**](docs/DefaultApi.md#emailaddget) | **GET** /email/add | Создание почтового ящика
*DefaultApi* | [**EmailAliasDeleteGet**](docs/DefaultApi.md#emailaliasdeleteget) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
*DefaultApi* | [**EmailAliasListGet**](docs/DefaultApi.md#emailaliaslistget) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
*DefaultApi* | [**EmailDeleteGet**](docs/DefaultApi.md#emaildeleteget) | **GET** /email/delete | Удаление почтового ящика
*DefaultApi* | [**EmailListGet**](docs/DefaultApi.md#emaillistget) | **GET** /email/list | Получить список почтовых ящиков
*DefaultApi* | [**UpdatesLastGet**](docs/DefaultApi.md#updateslastget) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
*DefaultApi* | [**UpdatesListGet**](docs/DefaultApi.md#updateslistget) | **GET** /updates/list | Список записей аудита
*DefaultApi* | [**WebsiteDeleteGet**](docs/DefaultApi.md#websitedeleteget) | **GET** /website/delete | Удаление сайта
*DefaultApi* | [**WebsiteListGet**](docs/DefaultApi.md#websitelistget) | **GET** /website/list | Список сайтов аккаунта
*AuthAPIApi* | [**AuthLoginPost**](docs/AuthAPIApi.md#authloginpost) | **POST** /auth/login | Получить ключ доступа
*AuthAPIApi* | [**AuthStartGet**](docs/AuthAPIApi.md#authstartget) | **GET** /auth/start | Получить соль
*DNSApi* | [**DnsAddGet**](docs/DNSApi.md#dnsaddget) | **GET** /dns/add | Создание записи домена
*DNSApi* | [**DnsBindGet**](docs/DNSApi.md#dnsbindget) | **GET** /dns/bind | Привязка одного домена к другому
*DNSApi* | [**DnsListGet**](docs/DNSApi.md#dnslistget) | **GET** /dns/list | Получить список доменных имён
*DNSApi* | [**DnsProlongListGet**](docs/DNSApi.md#dnsprolonglistget) | **GET** /dns/prolong/list | Информация по продлению доменов
*DNSApi* | [**DnsRawGet**](docs/DNSApi.md#dnsrawget) | **GET** /dns/raw | Редактирование \"сырой\" зоны
*DNSApi* | [**DnsRawManagedmxGet**](docs/DNSApi.md#dnsrawmanagedmxget) | **GET** /dns/raw/managedmx | Редактировать DNS-зону
*HostingftpAPIApi* | [**FtpListGet**](docs/HostingftpAPIApi.md#ftplistget) | **GET** /ftp/list | Получить список зарегистрированных аккаунтов FTP
*HostingiisAPIApi* | [**IisListGet**](docs/HostingiisAPIApi.md#iislistget) | **GET** /iis/list | Список сайтов IIS
*MicrosoftSQLServerApi* | [**MssqlListGet**](docs/MicrosoftSQLServerApi.md#mssqllistget) | **GET** /mssql/list | Получить список аккаунтов в MSSQL
*MySQLPostgresApi* | [**DatabaseListGet**](docs/MySQLPostgresApi.md#databaselistget) | **GET** /database/list | Список аккаунтов в базах данных UNIX
*VDSHyperVOpenVZApi* | [**VdsCreateGet**](docs/VDSHyperVOpenVZApi.md#vdscreateget) | **GET** /vds/create | Изменение параметров VDS
*VDSHyperVOpenVZApi* | [**VdsDeleteGet**](docs/VDSHyperVOpenVZApi.md#vdsdeleteget) | **GET** /vds/delete | Удаление VDS
*VDSHyperVOpenVZApi* | [**VdsIpAddGet**](docs/VDSHyperVOpenVZApi.md#vdsipaddget) | **GET** /vds/ip/add | Добавление IP на VDS
*VDSHyperVOpenVZApi* | [**VdsIpDeleteGet**](docs/VDSHyperVOpenVZApi.md#vdsipdeleteget) | **GET** /vds/ip/delete | Удаление IP с VDS
*VDSHyperVOpenVZApi* | [**VdsIpListGet**](docs/VDSHyperVOpenVZApi.md#vdsiplistget) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsListGet**](docs/VDSHyperVOpenVZApi.md#vdslistget) | **GET** /vds/list | Список виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsRebootGet**](docs/VDSHyperVOpenVZApi.md#vdsrebootget) | **GET** /vds/reboot | Перезагрузка VDS
*VDSHyperVOpenVZApi* | [**VdsTemplatesListGet**](docs/VDSHyperVOpenVZApi.md#vdstemplateslistget) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsUpdateGet**](docs/VDSHyperVOpenVZApi.md#vdsupdateget) | **GET** /vds/update | Создание VDS


<a name="documentation-for-models"></a>
## Documentation for Models

 - [Model.InlineResponse200](docs/InlineResponse200.md)
 - [Model.InlineResponse2001](docs/InlineResponse2001.md)
 - [Model.InlineResponse20010](docs/InlineResponse20010.md)
 - [Model.InlineResponse20011](docs/InlineResponse20011.md)
 - [Model.InlineResponse20012](docs/InlineResponse20012.md)
 - [Model.InlineResponse20013](docs/InlineResponse20013.md)
 - [Model.InlineResponse20014](docs/InlineResponse20014.md)
 - [Model.InlineResponse2002](docs/InlineResponse2002.md)
 - [Model.InlineResponse2003](docs/InlineResponse2003.md)
 - [Model.InlineResponse2004](docs/InlineResponse2004.md)
 - [Model.InlineResponse2005](docs/InlineResponse2005.md)
 - [Model.InlineResponse2006](docs/InlineResponse2006.md)
 - [Model.InlineResponse2007](docs/InlineResponse2007.md)
 - [Model.InlineResponse2008](docs/InlineResponse2008.md)
 - [Model.InlineResponse2009](docs/InlineResponse2009.md)
 - [Model._](docs/_.md)


## Documentation for Authorization

All endpoints do not require authorization.
