# IO.Swagger.Api.AuthAPIApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AuthLoginPost**](AuthAPIApi.md#authloginpost) | **POST** /auth/login | Получить ключ доступа
[**AuthStartGet**](AuthAPIApi.md#authstartget) | **GET** /auth/start | Получить соль


<a name="authloginpost"></a>
# **AuthLoginPost**
> string AuthLoginPost (string login, string salt, string response)

Получить ключ доступа

Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AuthLoginPostExample
    {
        public void main()
        {
            
            var apiInstance = new AuthAPIApi();
            var login = login_example;  // string | Имя пользователя
            var salt = salt_example;  // string | Соль (см. /auth/start)
            var response = response_example;  // string | Вычисленный хэш

            try
            {
                // Получить ключ доступа
                string result = apiInstance.AuthLoginPost(login, salt, response);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AuthAPIApi.AuthLoginPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **string**| Имя пользователя | 
 **salt** | **string**| Соль (см. /auth/start) | 
 **response** | **string**| Вычисленный хэш | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="authstartget"></a>
# **AuthStartGet**
> string AuthStartGet (string login)

Получить соль

Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AuthStartGetExample
    {
        public void main()
        {
            
            var apiInstance = new AuthAPIApi();
            var login = login_example;  // string | Имя пользователя

            try
            {
                // Получить соль
                string result = apiInstance.AuthStartGet(login);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AuthAPIApi.AuthStartGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **login** | **string**| Имя пользователя | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

