# IO.Swagger.Api.DNSApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DnsAddGet**](DNSApi.md#dnsaddget) | **GET** /dns/add | Создание записи домена
[**DnsBindGet**](DNSApi.md#dnsbindget) | **GET** /dns/bind | Привязка одного домена к другому
[**DnsListGet**](DNSApi.md#dnslistget) | **GET** /dns/list | Получить список доменных имён
[**DnsProlongListGet**](DNSApi.md#dnsprolonglistget) | **GET** /dns/prolong/list | Информация по продлению доменов
[**DnsRawGet**](DNSApi.md#dnsrawget) | **GET** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
[**DnsRawManagedmxGet**](DNSApi.md#dnsrawmanagedmxget) | **GET** /dns/raw/managedmx | Редактировать DNS-зону


<a name="dnsaddget"></a>
# **DnsAddGet**
> string DnsAddGet (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null)

Создание записи домена

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsAddGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var addDnsZone = addDnsZone_example;  // string | зона, которую необходимо создать
            var addDnsRecord = addDnsRecord_example;  // string |  (optional) 
            var iisSiteForDns = iisSiteForDns_example;  // string | ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional) 
            var bindOnly = true;  // bool? |  (optional) 

            try
            {
                // Создание записи домена
                string result = apiInstance.DnsAddGet(token_, addDnsZone, addDnsRecord, iisSiteForDns, bindOnly);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsAddGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **addDnsZone** | **string**| зона, которую необходимо создать | 
 **addDnsRecord** | **string**|  | [optional] 
 **iisSiteForDns** | **string**| ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку | [optional] 
 **bindOnly** | **bool?**|  | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnsbindget"></a>
# **DnsBindGet**
> string DnsBindGet (string token_, int? key_, string bindTo = null)

Привязка одного домена к другому

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsBindGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID домена из списка /dns/list
            var bindTo = bindTo_example;  // string | домен, к которому необходимо сделать привязку (optional) 

            try
            {
                // Привязка одного домена к другому
                string result = apiInstance.DnsBindGet(token_, key_, bindTo);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsBindGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID домена из списка /dns/list | 
 **bindTo** | **string**| домен, к которому необходимо сделать привязку | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnslistget"></a>
# **DnsListGet**
> List<InlineResponse2003> DnsListGet (string token_)

Получить список доменных имён

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Получить список доменных имён
                List&lt;InlineResponse2003&gt; result = apiInstance.DnsListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2003>**](InlineResponse2003.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnsprolonglistget"></a>
# **DnsProlongListGet**
> List<InlineResponse2004> DnsProlongListGet (string token_)

Информация по продлению доменов

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsProlongListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Информация по продлению доменов
                List&lt;InlineResponse2004&gt; result = apiInstance.DnsProlongListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsProlongListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2004>**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnsrawget"></a>
# **DnsRawGet**
> string DnsRawGet (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue)

Редактирование \"сырой\" зоны

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsRawGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID домена из /dns/list
            var sDel = 56;  // int? | Значение '1' сообщает, что запись необходимо удалить
            var sAdd = 56;  // int? | Значение '1' сообщает, что запись необходимо создать
            var dnsType = dnsType_example;  // string | Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
            var dnsName = dnsName_example;  // string | Имя записи, либо '@' для корневой
            var dnsValue = dnsValue_example;  // string | Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)

            try
            {
                // Редактирование \"сырой\" зоны
                string result = apiInstance.DnsRawGet(token_, key_, sDel, sAdd, dnsType, dnsName, dnsValue);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsRawGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID домена из /dns/list | 
 **sDel** | **int?**| Значение &#39;1&#39; сообщает, что запись необходимо удалить | 
 **sAdd** | **int?**| Значение &#39;1&#39; сообщает, что запись необходимо создать | 
 **dnsType** | **string**| Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV | 
 **dnsName** | **string**| Имя записи, либо &#39;@&#39; для корневой | 
 **dnsValue** | **string**| Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnsrawmanagedmxget"></a>
# **DnsRawManagedmxGet**
> string DnsRawManagedmxGet (string token_, int? key_, int? managedMx, int? updManagedMx)

Редактировать DNS-зону

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsRawManagedmxGetExample
    {
        public void main()
        {
            
            var apiInstance = new DNSApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID домена из /dns/list
            var managedMx = 56;  // int? | Значение '1', если необходимо включить поддержку на MX-серверах хостинга и '0', если выключить
            var updManagedMx = 56;  // int? | Значение '1' подтверждает операцию

            try
            {
                // Редактировать DNS-зону
                string result = apiInstance.DnsRawManagedmxGet(token_, key_, managedMx, updManagedMx);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DNSApi.DnsRawManagedmxGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID домена из /dns/list | 
 **managedMx** | **int?**| Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить | 
 **updManagedMx** | **int?**| Значение &#39;1&#39; подтверждает операцию | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

