# IO.Swagger.Api.DefaultApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BalanceGet**](DefaultApi.md#balanceget) | **GET** /balance | Аккаунт: баланс
[**BalanceLicGet**](DefaultApi.md#balancelicget) | **GET** /balance.lic | Аккаунт: баланс аккаунта лицензий
[**BillingDebtGet**](DefaultApi.md#billingdebtget) | **GET** /billing/debt | Информация по дебету аккаунта
[**BillingInfoGet**](DefaultApi.md#billinginfoget) | **GET** /billing/info | Информация об аккаунте
[**BillingLimitsGet**](DefaultApi.md#billinglimitsget) | **GET** /billing/limits | Получить ограничения аккаунта
[**DnsProlongListGet**](DefaultApi.md#dnsprolonglistget) | **GET** /dns/prolong/list | Информация по продлению доменов
[**EmailAddGet**](DefaultApi.md#emailaddget) | **GET** /email/add | Создание почтового ящика
[**EmailAliasDeleteGet**](DefaultApi.md#emailaliasdeleteget) | **GET** /email/alias/delete | Удаление псевдонимов почтовых ящиков
[**EmailAliasListGet**](DefaultApi.md#emailaliaslistget) | **GET** /email/alias/list | Получить список псевдонимов почтовых ящиков
[**EmailDeleteGet**](DefaultApi.md#emaildeleteget) | **GET** /email/delete | Удаление почтового ящика
[**EmailListGet**](DefaultApi.md#emaillistget) | **GET** /email/list | Получить список почтовых ящиков
[**UpdatesLastGet**](DefaultApi.md#updateslastget) | **GET** /updates/last | Идентификатор последнего уведомления в аудите
[**UpdatesListGet**](DefaultApi.md#updateslistget) | **GET** /updates/list | Список записей аудита
[**WebsiteDeleteGet**](DefaultApi.md#websitedeleteget) | **GET** /website/delete | Удаление сайта
[**WebsiteListGet**](DefaultApi.md#websitelistget) | **GET** /website/list | Список сайтов аккаунта


<a name="balanceget"></a>
# **BalanceGet**
> decimal? BalanceGet (string token_)

Аккаунт: баланс

Возвращает текущий баланс аккаунта

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BalanceGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Аккаунт: баланс
                decimal? result = apiInstance.BalanceGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BalanceGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**decimal?**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="balancelicget"></a>
# **BalanceLicGet**
> decimal? BalanceLicGet (string token_)

Аккаунт: баланс аккаунта лицензий

Возвращает текущий баланс аккаунта лицензий

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BalanceLicGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Аккаунт: баланс аккаунта лицензий
                decimal? result = apiInstance.BalanceLicGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BalanceLicGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**decimal?**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="billingdebtget"></a>
# **BillingDebtGet**
> List<InlineResponse200> BillingDebtGet (string token_)

Информация по дебету аккаунта

Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BillingDebtGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Информация по дебету аккаунта
                List&lt;InlineResponse200&gt; result = apiInstance.BillingDebtGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BillingDebtGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse200>**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="billinginfoget"></a>
# **BillingInfoGet**
> List<InlineResponse2001> BillingInfoGet (string token_)

Информация об аккаунте

Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BillingInfoGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Информация об аккаунте
                List&lt;InlineResponse2001&gt; result = apiInstance.BillingInfoGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BillingInfoGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2001>**](InlineResponse2001.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="billinglimitsget"></a>
# **BillingLimitsGet**
> _ BillingLimitsGet (string token_)

Получить ограничения аккаунта

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BillingLimitsGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Получить ограничения аккаунта
                _ result = apiInstance.BillingLimitsGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.BillingLimitsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**_**](_.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="dnsprolonglistget"></a>
# **DnsProlongListGet**
> List<InlineResponse2004> DnsProlongListGet (string token_)

Информация по продлению доменов

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DnsProlongListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Информация по продлению доменов
                List&lt;InlineResponse2004&gt; result = apiInstance.DnsProlongListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.DnsProlongListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2004>**](InlineResponse2004.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="emailaddget"></a>
# **EmailAddGet**
> string EmailAddGet (string token_, string addEmail)

Создание почтового ящика

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmailAddGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var addEmail = addEmail_example;  // string | Адрес почтового ящика, который необходимо создать

            try
            {
                // Создание почтового ящика
                string result = apiInstance.EmailAddGet(token_, addEmail);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.EmailAddGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **addEmail** | **string**| Адрес почтового ящика, который необходимо создать | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="emailaliasdeleteget"></a>
# **EmailAliasDeleteGet**
> string EmailAliasDeleteGet (string token_, string key_)

Удаление псевдонимов почтовых ящиков

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmailAliasDeleteGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = key__example;  // string | Адрес почтового ящика, подлежащего удалению

            try
            {
                // Удаление псевдонимов почтовых ящиков
                string result = apiInstance.EmailAliasDeleteGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.EmailAliasDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="emailaliaslistget"></a>
# **EmailAliasListGet**
> List<InlineResponse2005> EmailAliasListGet (string token_)

Получить список псевдонимов почтовых ящиков

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmailAliasListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Получить список псевдонимов почтовых ящиков
                List&lt;InlineResponse2005&gt; result = apiInstance.EmailAliasListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.EmailAliasListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2005>**](InlineResponse2005.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="emaildeleteget"></a>
# **EmailDeleteGet**
> string EmailDeleteGet (string token_, string key_)

Удаление почтового ящика

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmailDeleteGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = key__example;  // string | Адрес почтового ящика, подлежащего удалению

            try
            {
                // Удаление почтового ящика
                string result = apiInstance.EmailDeleteGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.EmailDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="emaillistget"></a>
# **EmailListGet**
> List<InlineResponse2006> EmailListGet (string token_)

Получить список почтовых ящиков

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmailListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Получить список почтовых ящиков
                List&lt;InlineResponse2006&gt; result = apiInstance.EmailListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.EmailListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse2006>**](InlineResponse2006.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateslastget"></a>
# **UpdatesLastGet**
> int? UpdatesLastGet (string token_)

Идентификатор последнего уведомления в аудите

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdatesLastGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Идентификатор последнего уведомления в аудите
                int? result = apiInstance.UpdatesLastGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.UpdatesLastGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**int?**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateslistget"></a>
# **UpdatesListGet**
> List<InlineResponse20010> UpdatesListGet (string token_, int? key_)

Список записей аудита

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdatesListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID первой записи для показа или 0 для показа всех записей

            try
            {
                // Список записей аудита
                List&lt;InlineResponse20010&gt; result = apiInstance.UpdatesListGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.UpdatesListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID первой записи для показа или 0 для показа всех записей | 

### Return type

[**List<InlineResponse20010>**](InlineResponse20010.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="websitedeleteget"></a>
# **WebsiteDeleteGet**
> string WebsiteDeleteGet (string token_, string key_)

Удаление сайта

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class WebsiteDeleteGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = key__example;  // string | ID сайта, полученный из /website/list

            try
            {
                // Удаление сайта
                string result = apiInstance.WebsiteDeleteGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.WebsiteDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| ID сайта, полученный из /website/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="websitelistget"></a>
# **WebsiteListGet**
> List<InlineResponse20014> WebsiteListGet (string token_)

Список сайтов аккаунта

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class WebsiteListGetExample
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Список сайтов аккаунта
                List&lt;InlineResponse20014&gt; result = apiInstance.WebsiteListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.WebsiteListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse20014>**](InlineResponse20014.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

