# IO.Swagger.Api.VDSHyperVOpenVZApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**VdsCreateGet**](VDSHyperVOpenVZApi.md#vdscreateget) | **GET** /vds/create | Изменение параметров VDS
[**VdsDeleteGet**](VDSHyperVOpenVZApi.md#vdsdeleteget) | **GET** /vds/delete | Удаление VDS
[**VdsIpAddGet**](VDSHyperVOpenVZApi.md#vdsipaddget) | **GET** /vds/ip/add | Добавление IP на VDS
[**VdsIpDeleteGet**](VDSHyperVOpenVZApi.md#vdsipdeleteget) | **GET** /vds/ip/delete | Удаление IP с VDS
[**VdsIpListGet**](VDSHyperVOpenVZApi.md#vdsiplistget) | **GET** /vds/ip/list | Список IP-адресов виртуальных серверов
[**VdsListGet**](VDSHyperVOpenVZApi.md#vdslistget) | **GET** /vds/list | Список виртуальных серверов
[**VdsRebootGet**](VDSHyperVOpenVZApi.md#vdsrebootget) | **GET** /vds/reboot | Перезагрузка VDS
[**VdsTemplatesListGet**](VDSHyperVOpenVZApi.md#vdstemplateslistget) | **GET** /vds/templates-list | Список шаблонов виртуальных серверов
[**VdsUpdateGet**](VDSHyperVOpenVZApi.md#vdsupdateget) | **GET** /vds/update | Создание VDS


<a name="vdscreateget"></a>
# **VdsCreateGet**
> string VdsCreateGet (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null)

Изменение параметров VDS

Изменение параметров уже существующего VDS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsCreateGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var type = type_example;  // string | Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic' (optional) 
            var crHvmem = 56;  // int? | Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional) 
            var crHvdsk = 56;  // int? | Количество доступных гигабайт диска. По умолчанию 30 (optional) 
            var crHvcpu = 56;  // int? | Количество ядер CPU. По умолчанию 2 (optional) 
            var template = template_example;  // string | Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional) 
            var forceMemo = forceMemo_example;  // string |  (optional) 
            var hv1gbPanelVersion = hv1gbPanelVersion_example;  // string |  (optional) 
            var panelInstall = true;  // bool? | Необходимо ли установить панель 1Gb на VDS (optional) 
            var crSsd1 = true;  // bool? | Создать всю систему на SSD (optional) 
            var crHvAllSystem = true;  // bool? | Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional) 

            try
            {
                // Изменение параметров VDS
                string result = apiInstance.VdsCreateGet(token_, type, crHvmem, crHvdsk, crHvcpu, template, forceMemo, hv1gbPanelVersion, panelInstall, crSsd1, crHvAllSystem);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsCreateGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **type** | **string**| Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; | [optional] 
 **crHvmem** | **int?**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **crHvdsk** | **int?**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **crHvcpu** | **int?**| Количество ядер CPU. По умолчанию 2 | [optional] 
 **template** | **string**| Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list | [optional] 
 **forceMemo** | **string**|  | [optional] 
 **hv1gbPanelVersion** | **string**|  | [optional] 
 **panelInstall** | **bool?**| Необходимо ли установить панель 1Gb на VDS | [optional] 
 **crSsd1** | **bool?**| Создать всю систему на SSD | [optional] 
 **crHvAllSystem** | **bool?**| Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsdeleteget"></a>
# **VdsDeleteGet**
> string VdsDeleteGet (string token_, int? key_, bool? forceCritical = null)

Удаление VDS

Предоставляет функционал для удаления VDS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsDeleteGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list
            var forceCritical = true;  // bool? | Если true, VDS будет удален срочно (optional) 

            try
            {
                // Удаление VDS
                string result = apiInstance.VdsDeleteGet(token_, key_, forceCritical);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | 
 **forceCritical** | **bool?**| Если true, VDS будет удален срочно | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsipaddget"></a>
# **VdsIpAddGet**
> string VdsIpAddGet (string token_, int? key_)

Добавление IP на VDS

Этот вызов позволяет добавить ещё один IP адрес на указанный VDS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsIpAddGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list

            try
            {
                // Добавление IP на VDS
                string result = apiInstance.VdsIpAddGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsIpAddGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsipdeleteget"></a>
# **VdsIpDeleteGet**
> string VdsIpDeleteGet (string token_, int? key_, string delIp)

Удаление IP с VDS

Этот вызов позволяет отвязать IP адрес от VDS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsIpDeleteGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list
            var delIp = delIp_example;  // string | IP адрес, который необходимо удалить

            try
            {
                // Удаление IP с VDS
                string result = apiInstance.VdsIpDeleteGet(token_, key_, delIp);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsIpDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | 
 **delIp** | **string**| IP адрес, который необходимо удалить | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsiplistget"></a>
# **VdsIpListGet**
> List<InlineResponse20011> VdsIpListGet (string token_, int? key_ = null)

Список IP-адресов виртуальных серверов

Список IP-адресов виртуальных серверов

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsIpListGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list (optional) 

            try
            {
                // Список IP-адресов виртуальных серверов
                List&lt;InlineResponse20011&gt; result = apiInstance.VdsIpListGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsIpListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | [optional] 

### Return type

[**List<InlineResponse20011>**](InlineResponse20011.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdslistget"></a>
# **VdsListGet**
> List<InlineResponse20012> VdsListGet (string token_, int? key_ = null)

Список виртуальных серверов

Позволяет получить список виртуальных серверов

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsListGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional) 

            try
            {
                // Список виртуальных серверов
                List&lt;InlineResponse20012&gt; result = apiInstance.VdsListGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS | [optional] 

### Return type

[**List<InlineResponse20012>**](InlineResponse20012.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsrebootget"></a>
# **VdsRebootGet**
> string VdsRebootGet (string token_, int? key_)

Перезагрузка VDS

Предоставляет функционал для перезагрузки VDS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsRebootGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list

            try
            {
                // Перезагрузка VDS
                string result = apiInstance.VdsRebootGet(token_, key_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsRebootGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdstemplateslistget"></a>
# **VdsTemplatesListGet**
> List<InlineResponse20013> VdsTemplatesListGet (string token_)

Список шаблонов виртуальных серверов

Позволяет получить список шаблонов виртуальных серверов

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsTemplatesListGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации

            try
            {
                // Список шаблонов виртуальных серверов
                List&lt;InlineResponse20013&gt; result = apiInstance.VdsTemplatesListGet(token_);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsTemplatesListGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**List<InlineResponse20013>**](InlineResponse20013.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vdsupdateget"></a>
# **VdsUpdateGet**
> string VdsUpdateGet (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null)

Создание VDS

Создание новых VDS с произвольными характеристиками

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VdsUpdateGetExample
    {
        public void main()
        {
            
            var apiInstance = new VDSHyperVOpenVZApi();
            var token_ = token__example;  // string | Ключ доступа, полученный при авторизации
            var key_ = 56;  // int? | ID виртуального сервера, полученный из /vds/list
            var crHvmem = 56;  // int? | Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional) 
            var crHvdsk = 56;  // int? | Количество доступных гигабайт диска. По умолчанию 30 (optional) 
            var crHvcpu = 56;  // int? | Количество ядер CPU. По умолчанию 2 (optional) 

            try
            {
                // Создание VDS
                string result = apiInstance.VdsUpdateGet(token_, key_, crHvmem, crHvdsk, crHvcpu);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VDSHyperVOpenVZApi.VdsUpdateGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int?**| ID виртуального сервера, полученный из /vds/list | 
 **crHvmem** | **int?**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **crHvdsk** | **int?**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **crHvcpu** | **int?**| Количество ядер CPU. По умолчанию 2 | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

