/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using NUnit.Framework;

using IO.Swagger.Client;
using IO.Swagger.Api;
using IO.Swagger.Model;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing DNSApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    [TestFixture]
    public class DNSApiTests
    {
        private DNSApi instance;

        /// <summary>
        /// Setup before each unit test
        /// </summary>
        [SetUp]
        public void Init()
        {
            instance = new DNSApi();
        }

        /// <summary>
        /// Clean up after each unit test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of DNSApi
        /// </summary>
        [Test]
        public void InstanceTest()
        {
            // test 'IsInstanceOfType' DNSApi
            Assert.IsInstanceOfType(typeof(DNSApi), instance, "instance is a DNSApi");
        }

        
        /// <summary>
        /// Test DnsAddGet
        /// </summary>
        [Test]
        public void DnsAddGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //string addDnsZone = null;
            //string addDnsRecord = null;
            //string iisSiteForDns = null;
            //bool? bindOnly = null;
            //var response = instance.DnsAddGet(token_, addDnsZone, addDnsRecord, iisSiteForDns, bindOnly);
            //Assert.IsInstanceOf<string> (response, "response is string");
        }
        
        /// <summary>
        /// Test DnsBindGet
        /// </summary>
        [Test]
        public void DnsBindGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //int? key_ = null;
            //string bindTo = null;
            //var response = instance.DnsBindGet(token_, key_, bindTo);
            //Assert.IsInstanceOf<string> (response, "response is string");
        }
        
        /// <summary>
        /// Test DnsListGet
        /// </summary>
        [Test]
        public void DnsListGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //var response = instance.DnsListGet(token_);
            //Assert.IsInstanceOf<List<InlineResponse2003>> (response, "response is List<InlineResponse2003>");
        }
        
        /// <summary>
        /// Test DnsProlongListGet
        /// </summary>
        [Test]
        public void DnsProlongListGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //var response = instance.DnsProlongListGet(token_);
            //Assert.IsInstanceOf<List<InlineResponse2004>> (response, "response is List<InlineResponse2004>");
        }
        
        /// <summary>
        /// Test DnsRawGet
        /// </summary>
        [Test]
        public void DnsRawGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //int? key_ = null;
            //int? sDel = null;
            //int? sAdd = null;
            //string dnsType = null;
            //string dnsName = null;
            //string dnsValue = null;
            //var response = instance.DnsRawGet(token_, key_, sDel, sAdd, dnsType, dnsName, dnsValue);
            //Assert.IsInstanceOf<string> (response, "response is string");
        }
        
        /// <summary>
        /// Test DnsRawManagedmxGet
        /// </summary>
        [Test]
        public void DnsRawManagedmxGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string token_ = null;
            //int? key_ = null;
            //int? managedMx = null;
            //int? updManagedMx = null;
            //var response = instance.DnsRawManagedmxGet(token_, key_, managedMx, updManagedMx);
            //Assert.IsInstanceOf<string> (response, "response is string");
        }
        
    }

}
