/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


using NUnit.Framework;

using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;
using IO.Swagger.Api;
using IO.Swagger.Model;
using IO.Swagger.Client;
using System.Reflection;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing InlineResponse20014
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the model.
    /// </remarks>
    [TestFixture]
    public class InlineResponse20014Tests
    {
        // TODO uncomment below to declare an instance variable for InlineResponse20014
        //private InlineResponse20014 instance;

        /// <summary>
        /// Setup before each test
        /// </summary>
        [SetUp]
        public void Init()
        {
            // TODO uncomment below to create an instance of InlineResponse20014
            //instance = new InlineResponse20014();
        }

        /// <summary>
        /// Clean up after each test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of InlineResponse20014
        /// </summary>
        [Test]
        public void InlineResponse20014InstanceTest()
        {
            // TODO uncomment below to test "IsInstanceOfType" InlineResponse20014
            //Assert.IsInstanceOfType<InlineResponse20014> (instance, "variable 'instance' is a InlineResponse20014");
        }

        /// <summary>
        /// Test the property 'Id'
        /// </summary>
        [Test]
        public void IdTest()
        {
            // TODO unit test for the property 'Id'
        }
        /// <summary>
        /// Test the property 'Status'
        /// </summary>
        [Test]
        public void StatusTest()
        {
            // TODO unit test for the property 'Status'
        }
        /// <summary>
        /// Test the property 'Unmovable'
        /// </summary>
        [Test]
        public void UnmovableTest()
        {
            // TODO unit test for the property 'Unmovable'
        }
        /// <summary>
        /// Test the property 'Online'
        /// </summary>
        [Test]
        public void OnlineTest()
        {
            // TODO unit test for the property 'Online'
        }
        /// <summary>
        /// Test the property 'Deleted'
        /// </summary>
        [Test]
        public void DeletedTest()
        {
            // TODO unit test for the property 'Deleted'
        }
        /// <summary>
        /// Test the property 'DeletedAuto'
        /// </summary>
        [Test]
        public void DeletedAutoTest()
        {
            // TODO unit test for the property 'DeletedAuto'
        }
        /// <summary>
        /// Test the property 'DeletedDump'
        /// </summary>
        [Test]
        public void DeletedDumpTest()
        {
            // TODO unit test for the property 'DeletedDump'
        }
        /// <summary>
        /// Test the property 'UserId'
        /// </summary>
        [Test]
        public void UserIdTest()
        {
            // TODO unit test for the property 'UserId'
        }
        /// <summary>
        /// Test the property 'FtpId'
        /// </summary>
        [Test]
        public void FtpIdTest()
        {
            // TODO unit test for the property 'FtpId'
        }
        /// <summary>
        /// Test the property 'DnsId'
        /// </summary>
        [Test]
        public void DnsIdTest()
        {
            // TODO unit test for the property 'DnsId'
        }
        /// <summary>
        /// Test the property 'IisId'
        /// </summary>
        [Test]
        public void IisIdTest()
        {
            // TODO unit test for the property 'IisId'
        }
        /// <summary>
        /// Test the property 'IisBinding'
        /// </summary>
        [Test]
        public void IisBindingTest()
        {
            // TODO unit test for the property 'IisBinding'
        }
        /// <summary>
        /// Test the property 'IisPath'
        /// </summary>
        [Test]
        public void IisPathTest()
        {
            // TODO unit test for the property 'IisPath'
        }
        /// <summary>
        /// Test the property 'IisComments'
        /// </summary>
        [Test]
        public void IisCommentsTest()
        {
            // TODO unit test for the property 'IisComments'
        }
        /// <summary>
        /// Test the property 'Memo'
        /// </summary>
        [Test]
        public void MemoTest()
        {
            // TODO unit test for the property 'Memo'
        }
        /// <summary>
        /// Test the property 'DateReg'
        /// </summary>
        [Test]
        public void DateRegTest()
        {
            // TODO unit test for the property 'DateReg'
        }
        /// <summary>
        /// Test the property 'Server'
        /// </summary>
        [Test]
        public void ServerTest()
        {
            // TODO unit test for the property 'Server'
        }
        /// <summary>
        /// Test the property 'ServerBak'
        /// </summary>
        [Test]
        public void ServerBakTest()
        {
            // TODO unit test for the property 'ServerBak'
        }
        /// <summary>
        /// Test the property 'ServerAux'
        /// </summary>
        [Test]
        public void ServerAuxTest()
        {
            // TODO unit test for the property 'ServerAux'
        }
        /// <summary>
        /// Test the property 'ServerTransition'
        /// </summary>
        [Test]
        public void ServerTransitionTest()
        {
            // TODO unit test for the property 'ServerTransition'
        }
        /// <summary>
        /// Test the property 'ServerTransitionDtc'
        /// </summary>
        [Test]
        public void ServerTransitionDtcTest()
        {
            // TODO unit test for the property 'ServerTransitionDtc'
        }
        /// <summary>
        /// Test the property 'BlockTransfer'
        /// </summary>
        [Test]
        public void BlockTransferTest()
        {
            // TODO unit test for the property 'BlockTransfer'
        }
        /// <summary>
        /// Test the property 'ServerChangedTime'
        /// </summary>
        [Test]
        public void ServerChangedTimeTest()
        {
            // TODO unit test for the property 'ServerChangedTime'
        }
        /// <summary>
        /// Test the property 'SizeAmount'
        /// </summary>
        [Test]
        public void SizeAmountTest()
        {
            // TODO unit test for the property 'SizeAmount'
        }
        /// <summary>
        /// Test the property 'SizeFileCount'
        /// </summary>
        [Test]
        public void SizeFileCountTest()
        {
            // TODO unit test for the property 'SizeFileCount'
        }
        /// <summary>
        /// Test the property 'SizeFileCountLimit'
        /// </summary>
        [Test]
        public void SizeFileCountLimitTest()
        {
            // TODO unit test for the property 'SizeFileCountLimit'
        }
        /// <summary>
        /// Test the property 'SizeDate'
        /// </summary>
        [Test]
        public void SizeDateTest()
        {
            // TODO unit test for the property 'SizeDate'
        }
        /// <summary>
        /// Test the property 'SizePriorityScan'
        /// </summary>
        [Test]
        public void SizePriorityScanTest()
        {
            // TODO unit test for the property 'SizePriorityScan'
        }
        /// <summary>
        /// Test the property 'CopyLogs'
        /// </summary>
        [Test]
        public void CopyLogsTest()
        {
            // TODO unit test for the property 'CopyLogs'
        }
        /// <summary>
        /// Test the property 'ContentComments'
        /// </summary>
        [Test]
        public void ContentCommentsTest()
        {
            // TODO unit test for the property 'ContentComments'
        }
        /// <summary>
        /// Test the property 'ContentCommentsVerbose'
        /// </summary>
        [Test]
        public void ContentCommentsVerboseTest()
        {
            // TODO unit test for the property 'ContentCommentsVerbose'
        }
        /// <summary>
        /// Test the property 'MetaSaveCount'
        /// </summary>
        [Test]
        public void MetaSaveCountTest()
        {
            // TODO unit test for the property 'MetaSaveCount'
        }
        /// <summary>
        /// Test the property 'BaseFolder'
        /// </summary>
        [Test]
        public void BaseFolderTest()
        {
            // TODO unit test for the property 'BaseFolder'
        }
        /// <summary>
        /// Test the property 'VirtualhostConf'
        /// </summary>
        [Test]
        public void VirtualhostConfTest()
        {
            // TODO unit test for the property 'VirtualhostConf'
        }
        /// <summary>
        /// Test the property 'VirtualhostServer'
        /// </summary>
        [Test]
        public void VirtualhostServerTest()
        {
            // TODO unit test for the property 'VirtualhostServer'
        }
        /// <summary>
        /// Test the property 'VirtualhostServerConf'
        /// </summary>
        [Test]
        public void VirtualhostServerConfTest()
        {
            // TODO unit test for the property 'VirtualhostServerConf'
        }
        /// <summary>
        /// Test the property 'LiveDayCount'
        /// </summary>
        [Test]
        public void LiveDayCountTest()
        {
            // TODO unit test for the property 'LiveDayCount'
        }
        /// <summary>
        /// Test the property 'ScanDate'
        /// </summary>
        [Test]
        public void ScanDateTest()
        {
            // TODO unit test for the property 'ScanDate'
        }
        /// <summary>
        /// Test the property 'GlobalTransferCount'
        /// </summary>
        [Test]
        public void GlobalTransferCountTest()
        {
            // TODO unit test for the property 'GlobalTransferCount'
        }
        /// <summary>
        /// Test the property 'NetLimitFile'
        /// </summary>
        [Test]
        public void NetLimitFileTest()
        {
            // TODO unit test for the property 'NetLimitFile'
        }
        /// <summary>
        /// Test the property 'NetLimitDenyFromIp'
        /// </summary>
        [Test]
        public void NetLimitDenyFromIpTest()
        {
            // TODO unit test for the property 'NetLimitDenyFromIp'
        }
        /// <summary>
        /// Test the property 'NetLimitDenyFromAgent'
        /// </summary>
        [Test]
        public void NetLimitDenyFromAgentTest()
        {
            // TODO unit test for the property 'NetLimitDenyFromAgent'
        }
        /// <summary>
        /// Test the property 'ApachePhpPooled'
        /// </summary>
        [Test]
        public void ApachePhpPooledTest()
        {
            // TODO unit test for the property 'ApachePhpPooled'
        }
        /// <summary>
        /// Test the property 'ApachePhpPooledExt'
        /// </summary>
        [Test]
        public void ApachePhpPooledExtTest()
        {
            // TODO unit test for the property 'ApachePhpPooledExt'
        }
        /// <summary>
        /// Test the property 'ApachePhpPooledExtAuto'
        /// </summary>
        [Test]
        public void ApachePhpPooledExtAutoTest()
        {
            // TODO unit test for the property 'ApachePhpPooledExtAuto'
        }
        /// <summary>
        /// Test the property 'ApachePhpPool1Only'
        /// </summary>
        [Test]
        public void ApachePhpPool1OnlyTest()
        {
            // TODO unit test for the property 'ApachePhpPool1Only'
        }
        /// <summary>
        /// Test the property 'ApachePhpPool5Only'
        /// </summary>
        [Test]
        public void ApachePhpPool5OnlyTest()
        {
            // TODO unit test for the property 'ApachePhpPool5Only'
        }
        /// <summary>
        /// Test the property 'ApacheSsi'
        /// </summary>
        [Test]
        public void ApacheSsiTest()
        {
            // TODO unit test for the property 'ApacheSsi'
        }
        /// <summary>
        /// Test the property 'BypassSecurity'
        /// </summary>
        [Test]
        public void BypassSecurityTest()
        {
            // TODO unit test for the property 'BypassSecurity'
        }
        /// <summary>
        /// Test the property 'FlagGenericExec'
        /// </summary>
        [Test]
        public void FlagGenericExecTest()
        {
            // TODO unit test for the property 'FlagGenericExec'
        }
        /// <summary>
        /// Test the property 'FlagNoWww'
        /// </summary>
        [Test]
        public void FlagNoWwwTest()
        {
            // TODO unit test for the property 'FlagNoWww'
        }
        /// <summary>
        /// Test the property 'BaseFolderSuffix'
        /// </summary>
        [Test]
        public void BaseFolderSuffixTest()
        {
            // TODO unit test for the property 'BaseFolderSuffix'
        }
        /// <summary>
        /// Test the property 'FeedbackSpeed'
        /// </summary>
        [Test]
        public void FeedbackSpeedTest()
        {
            // TODO unit test for the property 'FeedbackSpeed'
        }
        /// <summary>
        /// Test the property 'FeedbackSpeedDtc'
        /// </summary>
        [Test]
        public void FeedbackSpeedDtcTest()
        {
            // TODO unit test for the property 'FeedbackSpeedDtc'
        }
        /// <summary>
        /// Test the property 'FeedbackSpeedFeedback'
        /// </summary>
        [Test]
        public void FeedbackSpeedFeedbackTest()
        {
            // TODO unit test for the property 'FeedbackSpeedFeedback'
        }
        /// <summary>
        /// Test the property 'UnixPathOnWindows'
        /// </summary>
        [Test]
        public void UnixPathOnWindowsTest()
        {
            // TODO unit test for the property 'UnixPathOnWindows'
        }
        /// <summary>
        /// Test the property 'FtpIpfilter'
        /// </summary>
        [Test]
        public void FtpIpfilterTest()
        {
            // TODO unit test for the property 'FtpIpfilter'
        }
        /// <summary>
        /// Test the property 'SshIpfilter'
        /// </summary>
        [Test]
        public void SshIpfilterTest()
        {
            // TODO unit test for the property 'SshIpfilter'
        }
        /// <summary>
        /// Test the property 'L3dAuto'
        /// </summary>
        [Test]
        public void L3dAutoTest()
        {
            // TODO unit test for the property 'L3dAuto'
        }
        /// <summary>
        /// Test the property 'AwstatsPrimaryDomain'
        /// </summary>
        [Test]
        public void AwstatsPrimaryDomainTest()
        {
            // TODO unit test for the property 'AwstatsPrimaryDomain'
        }
        /// <summary>
        /// Test the property 'SharepointMode'
        /// </summary>
        [Test]
        public void SharepointModeTest()
        {
            // TODO unit test for the property 'SharepointMode'
        }
        /// <summary>
        /// Test the property 'SharepointModePending'
        /// </summary>
        [Test]
        public void SharepointModePendingTest()
        {
            // TODO unit test for the property 'SharepointModePending'
        }
        /// <summary>
        /// Test the property 'ApacheGenericPoolPort'
        /// </summary>
        [Test]
        public void ApacheGenericPoolPortTest()
        {
            // TODO unit test for the property 'ApacheGenericPoolPort'
        }
        /// <summary>
        /// Test the property 'MongrelEnvironment'
        /// </summary>
        [Test]
        public void MongrelEnvironmentTest()
        {
            // TODO unit test for the property 'MongrelEnvironment'
        }
        /// <summary>
        /// Test the property 'FlagFree'
        /// </summary>
        [Test]
        public void FlagFreeTest()
        {
            // TODO unit test for the property 'FlagFree'
        }
        /// <summary>
        /// Test the property 'RtmScanDate'
        /// </summary>
        [Test]
        public void RtmScanDateTest()
        {
            // TODO unit test for the property 'RtmScanDate'
        }
        /// <summary>
        /// Test the property 'AnalyzeAnalog'
        /// </summary>
        [Test]
        public void AnalyzeAnalogTest()
        {
            // TODO unit test for the property 'AnalyzeAnalog'
        }
        /// <summary>
        /// Test the property 'CpuDetailsEnabled'
        /// </summary>
        [Test]
        public void CpuDetailsEnabledTest()
        {
            // TODO unit test for the property 'CpuDetailsEnabled'
        }
        /// <summary>
        /// Test the property 'ContentModeratedStatus'
        /// </summary>
        [Test]
        public void ContentModeratedStatusTest()
        {
            // TODO unit test for the property 'ContentModeratedStatus'
        }
        /// <summary>
        /// Test the property 'ContentModeratedDate'
        /// </summary>
        [Test]
        public void ContentModeratedDateTest()
        {
            // TODO unit test for the property 'ContentModeratedDate'
        }
        /// <summary>
        /// Test the property 'HttpFrontendIp'
        /// </summary>
        [Test]
        public void HttpFrontendIpTest()
        {
            // TODO unit test for the property 'HttpFrontendIp'
        }
        /// <summary>
        /// Test the property 'HttpFrontendIpTransition'
        /// </summary>
        [Test]
        public void HttpFrontendIpTransitionTest()
        {
            // TODO unit test for the property 'HttpFrontendIpTransition'
        }
        /// <summary>
        /// Test the property 'CpuLimitExceededDate'
        /// </summary>
        [Test]
        public void CpuLimitExceededDateTest()
        {
            // TODO unit test for the property 'CpuLimitExceededDate'
        }
        /// <summary>
        /// Test the property 'AufsTemplate'
        /// </summary>
        [Test]
        public void AufsTemplateTest()
        {
            // TODO unit test for the property 'AufsTemplate'
        }
        /// <summary>
        /// Test the property 'OptionsAutolimit'
        /// </summary>
        [Test]
        public void OptionsAutolimitTest()
        {
            // TODO unit test for the property 'OptionsAutolimit'
        }
        /// <summary>
        /// Test the property 'IisCreationCommands'
        /// </summary>
        [Test]
        public void IisCreationCommandsTest()
        {
            // TODO unit test for the property 'IisCreationCommands'
        }
        /// <summary>
        /// Test the property 'IisCreationCommandsUnix'
        /// </summary>
        [Test]
        public void IisCreationCommandsUnixTest()
        {
            // TODO unit test for the property 'IisCreationCommandsUnix'
        }
        /// <summary>
        /// Test the property 'ThumbDate'
        /// </summary>
        [Test]
        public void ThumbDateTest()
        {
            // TODO unit test for the property 'ThumbDate'
        }
        /// <summary>
        /// Test the property 'ThumbFailed'
        /// </summary>
        [Test]
        public void ThumbFailedTest()
        {
            // TODO unit test for the property 'ThumbFailed'
        }
        /// <summary>
        /// Test the property 'BackupStatDate'
        /// </summary>
        [Test]
        public void BackupStatDateTest()
        {
            // TODO unit test for the property 'BackupStatDate'
        }
        /// <summary>
        /// Test the property 'BackupDate'
        /// </summary>
        [Test]
        public void BackupDateTest()
        {
            // TODO unit test for the property 'BackupDate'
        }
        /// <summary>
        /// Test the property 'DetectedPackages'
        /// </summary>
        [Test]
        public void DetectedPackagesTest()
        {
            // TODO unit test for the property 'DetectedPackages'
        }
        /// <summary>
        /// Test the property 'StatSitePower'
        /// </summary>
        [Test]
        public void StatSitePowerTest()
        {
            // TODO unit test for the property 'StatSitePower'
        }
        /// <summary>
        /// Test the property 'SmtpFrom'
        /// </summary>
        [Test]
        public void SmtpFromTest()
        {
            // TODO unit test for the property 'SmtpFrom'
        }
        /// <summary>
        /// Test the property 'SuperBackupDate'
        /// </summary>
        [Test]
        public void SuperBackupDateTest()
        {
            // TODO unit test for the property 'SuperBackupDate'
        }
        /// <summary>
        /// Test the property 'BackupDeltaStatDate'
        /// </summary>
        [Test]
        public void BackupDeltaStatDateTest()
        {
            // TODO unit test for the property 'BackupDeltaStatDate'
        }
        /// <summary>
        /// Test the property 'BackupDeltaDate'
        /// </summary>
        [Test]
        public void BackupDeltaDateTest()
        {
            // TODO unit test for the property 'BackupDeltaDate'
        }
        /// <summary>
        /// Test the property 'BackupDeltaDesc'
        /// </summary>
        [Test]
        public void BackupDeltaDescTest()
        {
            // TODO unit test for the property 'BackupDeltaDesc'
        }
        /// <summary>
        /// Test the property 'AltDocrootServer'
        /// </summary>
        [Test]
        public void AltDocrootServerTest()
        {
            // TODO unit test for the property 'AltDocrootServer'
        }
        /// <summary>
        /// Test the property 'AltDocrootPath'
        /// </summary>
        [Test]
        public void AltDocrootPathTest()
        {
            // TODO unit test for the property 'AltDocrootPath'
        }
        /// <summary>
        /// Test the property 'AltDocrootStatus'
        /// </summary>
        [Test]
        public void AltDocrootStatusTest()
        {
            // TODO unit test for the property 'AltDocrootStatus'
        }
        /// <summary>
        /// Test the property 'AltDocrootStatusCnt'
        /// </summary>
        [Test]
        public void AltDocrootStatusCntTest()
        {
            // TODO unit test for the property 'AltDocrootStatusCnt'
        }
        /// <summary>
        /// Test the property 'AltDocrootStatusDate'
        /// </summary>
        [Test]
        public void AltDocrootStatusDateTest()
        {
            // TODO unit test for the property 'AltDocrootStatusDate'
        }
        /// <summary>
        /// Test the property 'BindDtc'
        /// </summary>
        [Test]
        public void BindDtcTest()
        {
            // TODO unit test for the property 'BindDtc'
        }
        /// <summary>
        /// Test the property 'BackupSpecialMode'
        /// </summary>
        [Test]
        public void BackupSpecialModeTest()
        {
            // TODO unit test for the property 'BackupSpecialMode'
        }
        /// <summary>
        /// Test the property 'SizeCheckProblem'
        /// </summary>
        [Test]
        public void SizeCheckProblemTest()
        {
            // TODO unit test for the property 'SizeCheckProblem'
        }
        /// <summary>
        /// Test the property 'WpbDomain'
        /// </summary>
        [Test]
        public void WpbDomainTest()
        {
            // TODO unit test for the property 'WpbDomain'
        }
        /// <summary>
        /// Test the property 'WpbUuid'
        /// </summary>
        [Test]
        public void WpbUuidTest()
        {
            // TODO unit test for the property 'WpbUuid'
        }
        /// <summary>
        /// Test the property 'WpbStatus'
        /// </summary>
        [Test]
        public void WpbStatusTest()
        {
            // TODO unit test for the property 'WpbStatus'
        }
        /// <summary>
        /// Test the property 'AdminProtection'
        /// </summary>
        [Test]
        public void AdminProtectionTest()
        {
            // TODO unit test for the property 'AdminProtection'
        }
        /// <summary>
        /// Test the property 'SizeComments'
        /// </summary>
        [Test]
        public void SizeCommentsTest()
        {
            // TODO unit test for the property 'SizeComments'
        }
        /// <summary>
        /// Test the property 'AltDocrootSsdReq'
        /// </summary>
        [Test]
        public void AltDocrootSsdReqTest()
        {
            // TODO unit test for the property 'AltDocrootSsdReq'
        }
        /// <summary>
        /// Test the property 'MailLimit'
        /// </summary>
        [Test]
        public void MailLimitTest()
        {
            // TODO unit test for the property 'MailLimit'
        }
        /// <summary>
        /// Test the property 'MailAccept'
        /// </summary>
        [Test]
        public void MailAcceptTest()
        {
            // TODO unit test for the property 'MailAccept'
        }
        /// <summary>
        /// Test the property 'MailDrop'
        /// </summary>
        [Test]
        public void MailDropTest()
        {
            // TODO unit test for the property 'MailDrop'
        }
        /// <summary>
        /// Test the property 'FtpName'
        /// </summary>
        [Test]
        public void FtpNameTest()
        {
            // TODO unit test for the property 'FtpName'
        }
        /// <summary>
        /// Test the property 'FtpPwd'
        /// </summary>
        [Test]
        public void FtpPwdTest()
        {
            // TODO unit test for the property 'FtpPwd'
        }

    }

}
