/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


using NUnit.Framework;

using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;
using IO.Swagger.Api;
using IO.Swagger.Model;
using IO.Swagger.Client;
using System.Reflection;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing InlineResponse2001
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the model.
    /// </remarks>
    [TestFixture]
    public class InlineResponse2001Tests
    {
        // TODO uncomment below to declare an instance variable for InlineResponse2001
        //private InlineResponse2001 instance;

        /// <summary>
        /// Setup before each test
        /// </summary>
        [SetUp]
        public void Init()
        {
            // TODO uncomment below to create an instance of InlineResponse2001
            //instance = new InlineResponse2001();
        }

        /// <summary>
        /// Clean up after each test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of InlineResponse2001
        /// </summary>
        [Test]
        public void InlineResponse2001InstanceTest()
        {
            // TODO uncomment below to test "IsInstanceOfType" InlineResponse2001
            //Assert.IsInstanceOfType<InlineResponse2001> (instance, "variable 'instance' is a InlineResponse2001");
        }

        /// <summary>
        /// Test the property 'Id'
        /// </summary>
        [Test]
        public void IdTest()
        {
            // TODO unit test for the property 'Id'
        }
        /// <summary>
        /// Test the property 'Description'
        /// </summary>
        [Test]
        public void DescriptionTest()
        {
            // TODO unit test for the property 'Description'
        }
        /// <summary>
        /// Test the property 'BillingGroupId'
        /// </summary>
        [Test]
        public void BillingGroupIdTest()
        {
            // TODO unit test for the property 'BillingGroupId'
        }
        /// <summary>
        /// Test the property 'Blocked'
        /// </summary>
        [Test]
        public void BlockedTest()
        {
            // TODO unit test for the property 'Blocked'
        }
        /// <summary>
        /// Test the property 'BlockedDate'
        /// </summary>
        [Test]
        public void BlockedDateTest()
        {
            // TODO unit test for the property 'BlockedDate'
        }
        /// <summary>
        /// Test the property 'BlockedReason'
        /// </summary>
        [Test]
        public void BlockedReasonTest()
        {
            // TODO unit test for the property 'BlockedReason'
        }
        /// <summary>
        /// Test the property 'CreditLimit'
        /// </summary>
        [Test]
        public void CreditLimitTest()
        {
            // TODO unit test for the property 'CreditLimit'
        }
        /// <summary>
        /// Test the property 'PlanId'
        /// </summary>
        [Test]
        public void PlanIdTest()
        {
            // TODO unit test for the property 'PlanId'
        }
        /// <summary>
        /// Test the property 'PeriodId'
        /// </summary>
        [Test]
        public void PeriodIdTest()
        {
            // TODO unit test for the property 'PeriodId'
        }
        /// <summary>
        /// Test the property 'ContractType'
        /// </summary>
        [Test]
        public void ContractTypeTest()
        {
            // TODO unit test for the property 'ContractType'
        }
        /// <summary>
        /// Test the property 'ClientId'
        /// </summary>
        [Test]
        public void ClientIdTest()
        {
            // TODO unit test for the property 'ClientId'
        }
        /// <summary>
        /// Test the property 'ClientLogin'
        /// </summary>
        [Test]
        public void ClientLoginTest()
        {
            // TODO unit test for the property 'ClientLogin'
        }
        /// <summary>
        /// Test the property 'ContractId'
        /// </summary>
        [Test]
        public void ContractIdTest()
        {
            // TODO unit test for the property 'ContractId'
        }
        /// <summary>
        /// Test the property 'NameRus'
        /// </summary>
        [Test]
        public void NameRusTest()
        {
            // TODO unit test for the property 'NameRus'
        }
        /// <summary>
        /// Test the property 'NameEng'
        /// </summary>
        [Test]
        public void NameEngTest()
        {
            // TODO unit test for the property 'NameEng'
        }
        /// <summary>
        /// Test the property 'Email'
        /// </summary>
        [Test]
        public void EmailTest()
        {
            // TODO unit test for the property 'Email'
        }
        /// <summary>
        /// Test the property 'StatSites'
        /// </summary>
        [Test]
        public void StatSitesTest()
        {
            // TODO unit test for the property 'StatSites'
        }
        /// <summary>
        /// Test the property 'StatSizeMb'
        /// </summary>
        [Test]
        public void StatSizeMbTest()
        {
            // TODO unit test for the property 'StatSizeMb'
        }
        /// <summary>
        /// Test the property 'StatEmails'
        /// </summary>
        [Test]
        public void StatEmailsTest()
        {
            // TODO unit test for the property 'StatEmails'
        }
        /// <summary>
        /// Test the property 'StatMysqls'
        /// </summary>
        [Test]
        public void StatMysqlsTest()
        {
            // TODO unit test for the property 'StatMysqls'
        }
        /// <summary>
        /// Test the property 'StatTech'
        /// </summary>
        [Test]
        public void StatTechTest()
        {
            // TODO unit test for the property 'StatTech'
        }
        /// <summary>
        /// Test the property 'StatNicd'
        /// </summary>
        [Test]
        public void StatNicdTest()
        {
            // TODO unit test for the property 'StatNicd'
        }
        /// <summary>
        /// Test the property 'StatAccessDynamic'
        /// </summary>
        [Test]
        public void StatAccessDynamicTest()
        {
            // TODO unit test for the property 'StatAccessDynamic'
        }
        /// <summary>
        /// Test the property 'StatAccessStatic'
        /// </summary>
        [Test]
        public void StatAccessStaticTest()
        {
            // TODO unit test for the property 'StatAccessStatic'
        }
        /// <summary>
        /// Test the property 'StatAccessTraffic'
        /// </summary>
        [Test]
        public void StatAccessTrafficTest()
        {
            // TODO unit test for the property 'StatAccessTraffic'
        }
        /// <summary>
        /// Test the property 'StatPaidTotal'
        /// </summary>
        [Test]
        public void StatPaidTotalTest()
        {
            // TODO unit test for the property 'StatPaidTotal'
        }
        /// <summary>
        /// Test the property 'StatVdsSize'
        /// </summary>
        [Test]
        public void StatVdsSizeTest()
        {
            // TODO unit test for the property 'StatVdsSize'
        }
        /// <summary>
        /// Test the property 'PlanName'
        /// </summary>
        [Test]
        public void PlanNameTest()
        {
            // TODO unit test for the property 'PlanName'
        }
        /// <summary>
        /// Test the property 'PeriodMonths'
        /// </summary>
        [Test]
        public void PeriodMonthsTest()
        {
            // TODO unit test for the property 'PeriodMonths'
        }
        /// <summary>
        /// Test the property 'PeriodPrice'
        /// </summary>
        [Test]
        public void PeriodPriceTest()
        {
            // TODO unit test for the property 'PeriodPrice'
        }
        /// <summary>
        /// Test the property 'Expires'
        /// </summary>
        [Test]
        public void ExpiresTest()
        {
            // TODO unit test for the property 'Expires'
        }
        /// <summary>
        /// Test the property 'ExternalCurrencySpelledPrefix'
        /// </summary>
        [Test]
        public void ExternalCurrencySpelledPrefixTest()
        {
            // TODO unit test for the property 'ExternalCurrencySpelledPrefix'
        }
        /// <summary>
        /// Test the property 'ExternalCurrencySpelledSuffix'
        /// </summary>
        [Test]
        public void ExternalCurrencySpelledSuffixTest()
        {
            // TODO unit test for the property 'ExternalCurrencySpelledSuffix'
        }

    }

}
