/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDNSApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Создание записи домена
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>string</returns>
        string DnsAddGet (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null);

        /// <summary>
        /// Создание записи домена
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> DnsAddGetWithHttpInfo (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null);
        /// <summary>
        /// Привязка одного домена к другому
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>string</returns>
        string DnsBindGet (string token_, int? key_, string bindTo = null);

        /// <summary>
        /// Привязка одного домена к другому
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> DnsBindGetWithHttpInfo (string token_, int? key_, string bindTo = null);
        /// <summary>
        /// Получить список доменных имён
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2003&gt;</returns>
        List<InlineResponse2003> DnsListGet (string token_);

        /// <summary>
        /// Получить список доменных имён
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2003&gt;</returns>
        ApiResponse<List<InlineResponse2003>> DnsListGetWithHttpInfo (string token_);
        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2004&gt;</returns>
        List<InlineResponse2004> DnsProlongListGet (string token_);

        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2004&gt;</returns>
        ApiResponse<List<InlineResponse2004>> DnsProlongListGetWithHttpInfo (string token_);
        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>string</returns>
        string DnsRawGet (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue);

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> DnsRawGetWithHttpInfo (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue);
        /// <summary>
        /// Редактировать DNS-зону
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>string</returns>
        string DnsRawManagedmxGet (string token_, int? key_, int? managedMx, int? updManagedMx);

        /// <summary>
        /// Редактировать DNS-зону
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> DnsRawManagedmxGetWithHttpInfo (string token_, int? key_, int? managedMx, int? updManagedMx);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Создание записи домена
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> DnsAddGetAsync (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null);

        /// <summary>
        /// Создание записи домена
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> DnsAddGetAsyncWithHttpInfo (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null);
        /// <summary>
        /// Привязка одного домена к другому
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> DnsBindGetAsync (string token_, int? key_, string bindTo = null);

        /// <summary>
        /// Привязка одного домена к другому
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> DnsBindGetAsyncWithHttpInfo (string token_, int? key_, string bindTo = null);
        /// <summary>
        /// Получить список доменных имён
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2003&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2003>> DnsListGetAsync (string token_);

        /// <summary>
        /// Получить список доменных имён
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2003&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2003>>> DnsListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2004&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2004>> DnsProlongListGetAsync (string token_);

        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2004&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2004>>> DnsProlongListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> DnsRawGetAsync (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue);

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> DnsRawGetAsyncWithHttpInfo (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue);
        /// <summary>
        /// Редактировать DNS-зону
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> DnsRawManagedmxGetAsync (string token_, int? key_, int? managedMx, int? updManagedMx);

        /// <summary>
        /// Редактировать DNS-зону
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> DnsRawManagedmxGetAsyncWithHttpInfo (string token_, int? key_, int? managedMx, int? updManagedMx);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DNSApi : IDNSApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DNSApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DNSApi(String basePath)
        {
            this.Configuration = new Configuration(new ApiClient(basePath));

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DNSApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DNSApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public Dictionary<String, String> DefaultHeader()
        {
            return this.Configuration.DefaultHeader;
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Создание записи домена 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>string</returns>
        public string DnsAddGet (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null)
        {
             ApiResponse<string> localVarResponse = DnsAddGetWithHttpInfo(token_, addDnsZone, addDnsRecord, iisSiteForDns, bindOnly);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Создание записи домена 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > DnsAddGetWithHttpInfo (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsAddGet");
            // verify the required parameter 'addDnsZone' is set
            if (addDnsZone == null)
                throw new ApiException(400, "Missing required parameter 'addDnsZone' when calling DNSApi->DnsAddGet");

            var localVarPath = "/dns/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (addDnsZone != null) localVarQueryParams.Add("add_dns_zone", Configuration.ApiClient.ParameterToString(addDnsZone)); // query parameter
            if (addDnsRecord != null) localVarQueryParams.Add("add_dns_record", Configuration.ApiClient.ParameterToString(addDnsRecord)); // query parameter
            if (iisSiteForDns != null) localVarQueryParams.Add("iis_site_for_dns", Configuration.ApiClient.ParameterToString(iisSiteForDns)); // query parameter
            if (bindOnly != null) localVarQueryParams.Add("bind_only", Configuration.ApiClient.ParameterToString(bindOnly)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Создание записи домена 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> DnsAddGetAsync (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null)
        {
             ApiResponse<string> localVarResponse = await DnsAddGetAsyncWithHttpInfo(token_, addDnsZone, addDnsRecord, iisSiteForDns, bindOnly);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Создание записи домена 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addDnsZone">зона, которую необходимо создать</param>
        /// <param name="addDnsRecord"> (optional)</param>
        /// <param name="iisSiteForDns">ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)</param>
        /// <param name="bindOnly"> (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> DnsAddGetAsyncWithHttpInfo (string token_, string addDnsZone, string addDnsRecord = null, string iisSiteForDns = null, bool? bindOnly = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsAddGet");
            // verify the required parameter 'addDnsZone' is set
            if (addDnsZone == null)
                throw new ApiException(400, "Missing required parameter 'addDnsZone' when calling DNSApi->DnsAddGet");

            var localVarPath = "/dns/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (addDnsZone != null) localVarQueryParams.Add("add_dns_zone", Configuration.ApiClient.ParameterToString(addDnsZone)); // query parameter
            if (addDnsRecord != null) localVarQueryParams.Add("add_dns_record", Configuration.ApiClient.ParameterToString(addDnsRecord)); // query parameter
            if (iisSiteForDns != null) localVarQueryParams.Add("iis_site_for_dns", Configuration.ApiClient.ParameterToString(iisSiteForDns)); // query parameter
            if (bindOnly != null) localVarQueryParams.Add("bind_only", Configuration.ApiClient.ParameterToString(bindOnly)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Привязка одного домена к другому 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>string</returns>
        public string DnsBindGet (string token_, int? key_, string bindTo = null)
        {
             ApiResponse<string> localVarResponse = DnsBindGetWithHttpInfo(token_, key_, bindTo);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Привязка одного домена к другому 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > DnsBindGetWithHttpInfo (string token_, int? key_, string bindTo = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsBindGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsBindGet");

            var localVarPath = "/dns/bind";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (bindTo != null) localVarQueryParams.Add("bind_to", Configuration.ApiClient.ParameterToString(bindTo)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsBindGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Привязка одного домена к другому 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> DnsBindGetAsync (string token_, int? key_, string bindTo = null)
        {
             ApiResponse<string> localVarResponse = await DnsBindGetAsyncWithHttpInfo(token_, key_, bindTo);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Привязка одного домена к другому 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из списка /dns/list</param>
        /// <param name="bindTo">домен, к которому необходимо сделать привязку (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> DnsBindGetAsyncWithHttpInfo (string token_, int? key_, string bindTo = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsBindGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsBindGet");

            var localVarPath = "/dns/bind";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (bindTo != null) localVarQueryParams.Add("bind_to", Configuration.ApiClient.ParameterToString(bindTo)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsBindGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Получить список доменных имён 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2003&gt;</returns>
        public List<InlineResponse2003> DnsListGet (string token_)
        {
             ApiResponse<List<InlineResponse2003>> localVarResponse = DnsListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Получить список доменных имён 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2003&gt;</returns>
        public ApiResponse< List<InlineResponse2003> > DnsListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsListGet");

            var localVarPath = "/dns/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2003>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2003>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2003>)));
            
        }

        /// <summary>
        /// Получить список доменных имён 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2003&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2003>> DnsListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2003>> localVarResponse = await DnsListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Получить список доменных имён 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2003&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2003>>> DnsListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsListGet");

            var localVarPath = "/dns/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2003>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2003>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2003>)));
            
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2004&gt;</returns>
        public List<InlineResponse2004> DnsProlongListGet (string token_)
        {
             ApiResponse<List<InlineResponse2004>> localVarResponse = DnsProlongListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2004&gt;</returns>
        public ApiResponse< List<InlineResponse2004> > DnsProlongListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsProlongListGet");

            var localVarPath = "/dns/prolong/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsProlongListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2004>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2004>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2004>)));
            
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2004&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2004>> DnsProlongListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2004>> localVarResponse = await DnsProlongListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2004&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2004>>> DnsProlongListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsProlongListGet");

            var localVarPath = "/dns/prolong/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsProlongListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2004>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2004>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2004>)));
            
        }

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>string</returns>
        public string DnsRawGet (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue)
        {
             ApiResponse<string> localVarResponse = DnsRawGetWithHttpInfo(token_, key_, sDel, sAdd, dnsType, dnsName, dnsValue);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > DnsRawGetWithHttpInfo (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'sDel' is set
            if (sDel == null)
                throw new ApiException(400, "Missing required parameter 'sDel' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'sAdd' is set
            if (sAdd == null)
                throw new ApiException(400, "Missing required parameter 'sAdd' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsType' is set
            if (dnsType == null)
                throw new ApiException(400, "Missing required parameter 'dnsType' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsName' is set
            if (dnsName == null)
                throw new ApiException(400, "Missing required parameter 'dnsName' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsValue' is set
            if (dnsValue == null)
                throw new ApiException(400, "Missing required parameter 'dnsValue' when calling DNSApi->DnsRawGet");

            var localVarPath = "/dns/raw";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (sDel != null) localVarQueryParams.Add("s_del", Configuration.ApiClient.ParameterToString(sDel)); // query parameter
            if (sAdd != null) localVarQueryParams.Add("s_add", Configuration.ApiClient.ParameterToString(sAdd)); // query parameter
            if (dnsType != null) localVarQueryParams.Add("dns_type", Configuration.ApiClient.ParameterToString(dnsType)); // query parameter
            if (dnsName != null) localVarQueryParams.Add("dns_name", Configuration.ApiClient.ParameterToString(dnsName)); // query parameter
            if (dnsValue != null) localVarQueryParams.Add("dns_value", Configuration.ApiClient.ParameterToString(dnsValue)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsRawGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> DnsRawGetAsync (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue)
        {
             ApiResponse<string> localVarResponse = await DnsRawGetAsyncWithHttpInfo(token_, key_, sDel, sAdd, dnsType, dnsName, dnsValue);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Редактирование \&quot;сырой\&quot; зоны 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="sDel">Значение &#39;1&#39; сообщает, что запись необходимо удалить</param>
        /// <param name="sAdd">Значение &#39;1&#39; сообщает, что запись необходимо создать</param>
        /// <param name="dnsType">Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV</param>
        /// <param name="dnsName">Имя записи, либо &#39;@&#39; для корневой</param>
        /// <param name="dnsValue">Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> DnsRawGetAsyncWithHttpInfo (string token_, int? key_, int? sDel, int? sAdd, string dnsType, string dnsName, string dnsValue)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'sDel' is set
            if (sDel == null)
                throw new ApiException(400, "Missing required parameter 'sDel' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'sAdd' is set
            if (sAdd == null)
                throw new ApiException(400, "Missing required parameter 'sAdd' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsType' is set
            if (dnsType == null)
                throw new ApiException(400, "Missing required parameter 'dnsType' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsName' is set
            if (dnsName == null)
                throw new ApiException(400, "Missing required parameter 'dnsName' when calling DNSApi->DnsRawGet");
            // verify the required parameter 'dnsValue' is set
            if (dnsValue == null)
                throw new ApiException(400, "Missing required parameter 'dnsValue' when calling DNSApi->DnsRawGet");

            var localVarPath = "/dns/raw";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (sDel != null) localVarQueryParams.Add("s_del", Configuration.ApiClient.ParameterToString(sDel)); // query parameter
            if (sAdd != null) localVarQueryParams.Add("s_add", Configuration.ApiClient.ParameterToString(sAdd)); // query parameter
            if (dnsType != null) localVarQueryParams.Add("dns_type", Configuration.ApiClient.ParameterToString(dnsType)); // query parameter
            if (dnsName != null) localVarQueryParams.Add("dns_name", Configuration.ApiClient.ParameterToString(dnsName)); // query parameter
            if (dnsValue != null) localVarQueryParams.Add("dns_value", Configuration.ApiClient.ParameterToString(dnsValue)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsRawGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Редактировать DNS-зону 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>string</returns>
        public string DnsRawManagedmxGet (string token_, int? key_, int? managedMx, int? updManagedMx)
        {
             ApiResponse<string> localVarResponse = DnsRawManagedmxGetWithHttpInfo(token_, key_, managedMx, updManagedMx);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Редактировать DNS-зону 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > DnsRawManagedmxGetWithHttpInfo (string token_, int? key_, int? managedMx, int? updManagedMx)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'managedMx' is set
            if (managedMx == null)
                throw new ApiException(400, "Missing required parameter 'managedMx' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'updManagedMx' is set
            if (updManagedMx == null)
                throw new ApiException(400, "Missing required parameter 'updManagedMx' when calling DNSApi->DnsRawManagedmxGet");

            var localVarPath = "/dns/raw/managedmx";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (managedMx != null) localVarQueryParams.Add("managed_mx", Configuration.ApiClient.ParameterToString(managedMx)); // query parameter
            if (updManagedMx != null) localVarQueryParams.Add("upd_managed_mx", Configuration.ApiClient.ParameterToString(updManagedMx)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsRawManagedmxGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Редактировать DNS-зону 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> DnsRawManagedmxGetAsync (string token_, int? key_, int? managedMx, int? updManagedMx)
        {
             ApiResponse<string> localVarResponse = await DnsRawManagedmxGetAsyncWithHttpInfo(token_, key_, managedMx, updManagedMx);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Редактировать DNS-зону 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID домена из /dns/list</param>
        /// <param name="managedMx">Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить</param>
        /// <param name="updManagedMx">Значение &#39;1&#39; подтверждает операцию</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> DnsRawManagedmxGetAsyncWithHttpInfo (string token_, int? key_, int? managedMx, int? updManagedMx)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'managedMx' is set
            if (managedMx == null)
                throw new ApiException(400, "Missing required parameter 'managedMx' when calling DNSApi->DnsRawManagedmxGet");
            // verify the required parameter 'updManagedMx' is set
            if (updManagedMx == null)
                throw new ApiException(400, "Missing required parameter 'updManagedMx' when calling DNSApi->DnsRawManagedmxGet");

            var localVarPath = "/dns/raw/managedmx";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (managedMx != null) localVarQueryParams.Add("managed_mx", Configuration.ApiClient.ParameterToString(managedMx)); // query parameter
            if (updManagedMx != null) localVarQueryParams.Add("upd_managed_mx", Configuration.ApiClient.ParameterToString(updManagedMx)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsRawManagedmxGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

    }
}
