/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Аккаунт: баланс
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>decimal?</returns>
        decimal? BalanceGet (string token_);

        /// <summary>
        /// Аккаунт: баланс
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of decimal?</returns>
        ApiResponse<decimal?> BalanceGetWithHttpInfo (string token_);
        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта лицензий
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>decimal?</returns>
        decimal? BalanceLicGet (string token_);

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта лицензий
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of decimal?</returns>
        ApiResponse<decimal?> BalanceLicGetWithHttpInfo (string token_);
        /// <summary>
        /// Информация по дебету аккаунта
        /// </summary>
        /// <remarks>
        /// Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse200&gt;</returns>
        List<InlineResponse200> BillingDebtGet (string token_);

        /// <summary>
        /// Информация по дебету аккаунта
        /// </summary>
        /// <remarks>
        /// Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse200&gt;</returns>
        ApiResponse<List<InlineResponse200>> BillingDebtGetWithHttpInfo (string token_);
        /// <summary>
        /// Информация об аккаунте
        /// </summary>
        /// <remarks>
        /// Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2001&gt;</returns>
        List<InlineResponse2001> BillingInfoGet (string token_);

        /// <summary>
        /// Информация об аккаунте
        /// </summary>
        /// <remarks>
        /// Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2001&gt;</returns>
        ApiResponse<List<InlineResponse2001>> BillingInfoGetWithHttpInfo (string token_);
        /// <summary>
        /// Получить ограничения аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>_</returns>
        _ BillingLimitsGet (string token_);

        /// <summary>
        /// Получить ограничения аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of _</returns>
        ApiResponse<_> BillingLimitsGetWithHttpInfo (string token_);
        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2004&gt;</returns>
        List<InlineResponse2004> DnsProlongListGet (string token_);

        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2004&gt;</returns>
        ApiResponse<List<InlineResponse2004>> DnsProlongListGetWithHttpInfo (string token_);
        /// <summary>
        /// Создание почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>string</returns>
        string EmailAddGet (string token_, string addEmail);

        /// <summary>
        /// Создание почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> EmailAddGetWithHttpInfo (string token_, string addEmail);
        /// <summary>
        /// Удаление псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>string</returns>
        string EmailAliasDeleteGet (string token_, string key_);

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> EmailAliasDeleteGetWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Получить список псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2005&gt;</returns>
        List<InlineResponse2005> EmailAliasListGet (string token_);

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2005&gt;</returns>
        ApiResponse<List<InlineResponse2005>> EmailAliasListGetWithHttpInfo (string token_);
        /// <summary>
        /// Удаление почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>string</returns>
        string EmailDeleteGet (string token_, string key_);

        /// <summary>
        /// Удаление почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> EmailDeleteGetWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Получить список почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2006&gt;</returns>
        List<InlineResponse2006> EmailListGet (string token_);

        /// <summary>
        /// Получить список почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2006&gt;</returns>
        ApiResponse<List<InlineResponse2006>> EmailListGetWithHttpInfo (string token_);
        /// <summary>
        /// Идентификатор последнего уведомления в аудите
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>int?</returns>
        int? UpdatesLastGet (string token_);

        /// <summary>
        /// Идентификатор последнего уведомления в аудите
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of int?</returns>
        ApiResponse<int?> UpdatesLastGetWithHttpInfo (string token_);
        /// <summary>
        /// Список записей аудита
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>List&lt;InlineResponse20010&gt;</returns>
        List<InlineResponse20010> UpdatesListGet (string token_, int? key_);

        /// <summary>
        /// Список записей аудита
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20010&gt;</returns>
        ApiResponse<List<InlineResponse20010>> UpdatesListGetWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Удаление сайта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>string</returns>
        string WebsiteDeleteGet (string token_, string key_);

        /// <summary>
        /// Удаление сайта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> WebsiteDeleteGetWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Список сайтов аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse20014&gt;</returns>
        List<InlineResponse20014> WebsiteListGet (string token_);

        /// <summary>
        /// Список сайтов аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20014&gt;</returns>
        ApiResponse<List<InlineResponse20014>> WebsiteListGetWithHttpInfo (string token_);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Аккаунт: баланс
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of decimal?</returns>
        System.Threading.Tasks.Task<decimal?> BalanceGetAsync (string token_);

        /// <summary>
        /// Аккаунт: баланс
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (decimal?)</returns>
        System.Threading.Tasks.Task<ApiResponse<decimal?>> BalanceGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта лицензий
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of decimal?</returns>
        System.Threading.Tasks.Task<decimal?> BalanceLicGetAsync (string token_);

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий
        /// </summary>
        /// <remarks>
        /// Возвращает текущий баланс аккаунта лицензий
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (decimal?)</returns>
        System.Threading.Tasks.Task<ApiResponse<decimal?>> BalanceLicGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Информация по дебету аккаунта
        /// </summary>
        /// <remarks>
        /// Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse200&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse200>> BillingDebtGetAsync (string token_);

        /// <summary>
        /// Информация по дебету аккаунта
        /// </summary>
        /// <remarks>
        /// Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse200&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse200>>> BillingDebtGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Информация об аккаунте
        /// </summary>
        /// <remarks>
        /// Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2001&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2001>> BillingInfoGetAsync (string token_);

        /// <summary>
        /// Информация об аккаунте
        /// </summary>
        /// <remarks>
        /// Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2001&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2001>>> BillingInfoGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Получить ограничения аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of _</returns>
        System.Threading.Tasks.Task<_> BillingLimitsGetAsync (string token_);

        /// <summary>
        /// Получить ограничения аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (_)</returns>
        System.Threading.Tasks.Task<ApiResponse<_>> BillingLimitsGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2004&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2004>> DnsProlongListGetAsync (string token_);

        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2004&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2004>>> DnsProlongListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Создание почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> EmailAddGetAsync (string token_, string addEmail);

        /// <summary>
        /// Создание почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> EmailAddGetAsyncWithHttpInfo (string token_, string addEmail);
        /// <summary>
        /// Удаление псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> EmailAliasDeleteGetAsync (string token_, string key_);

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> EmailAliasDeleteGetAsyncWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Получить список псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2005&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2005>> EmailAliasListGetAsync (string token_);

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2005&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2005>>> EmailAliasListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Удаление почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> EmailDeleteGetAsync (string token_, string key_);

        /// <summary>
        /// Удаление почтового ящика
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> EmailDeleteGetAsyncWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Получить список почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2006&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse2006>> EmailListGetAsync (string token_);

        /// <summary>
        /// Получить список почтовых ящиков
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2006&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2006>>> EmailListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Идентификатор последнего уведомления в аудите
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of int?</returns>
        System.Threading.Tasks.Task<int?> UpdatesLastGetAsync (string token_);

        /// <summary>
        /// Идентификатор последнего уведомления в аудите
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (int?)</returns>
        System.Threading.Tasks.Task<ApiResponse<int?>> UpdatesLastGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Список записей аудита
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>Task of List&lt;InlineResponse20010&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse20010>> UpdatesListGetAsync (string token_, int? key_);

        /// <summary>
        /// Список записей аудита
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20010&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20010>>> UpdatesListGetAsyncWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Удаление сайта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> WebsiteDeleteGetAsync (string token_, string key_);

        /// <summary>
        /// Удаление сайта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> WebsiteDeleteGetAsyncWithHttpInfo (string token_, string key_);
        /// <summary>
        /// Список сайтов аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse20014&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse20014>> WebsiteListGetAsync (string token_);

        /// <summary>
        /// Список сайтов аккаунта
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20014&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20014>>> WebsiteListGetAsyncWithHttpInfo (string token_);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DefaultApi : IDefaultApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi(String basePath)
        {
            this.Configuration = new Configuration(new ApiClient(basePath));

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DefaultApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public Dictionary<String, String> DefaultHeader()
        {
            return this.Configuration.DefaultHeader;
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Аккаунт: баланс Возвращает текущий баланс аккаунта
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>decimal?</returns>
        public decimal? BalanceGet (string token_)
        {
             ApiResponse<decimal?> localVarResponse = BalanceGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Аккаунт: баланс Возвращает текущий баланс аккаунта
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of decimal?</returns>
        public ApiResponse< decimal? > BalanceGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BalanceGet");

            var localVarPath = "/balance";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BalanceGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<decimal?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (decimal?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(decimal?)));
            
        }

        /// <summary>
        /// Аккаунт: баланс Возвращает текущий баланс аккаунта
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of decimal?</returns>
        public async System.Threading.Tasks.Task<decimal?> BalanceGetAsync (string token_)
        {
             ApiResponse<decimal?> localVarResponse = await BalanceGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Аккаунт: баланс Возвращает текущий баланс аккаунта
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (decimal?)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<decimal?>> BalanceGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BalanceGet");

            var localVarPath = "/balance";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BalanceGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<decimal?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (decimal?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(decimal?)));
            
        }

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий Возвращает текущий баланс аккаунта лицензий
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>decimal?</returns>
        public decimal? BalanceLicGet (string token_)
        {
             ApiResponse<decimal?> localVarResponse = BalanceLicGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий Возвращает текущий баланс аккаунта лицензий
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of decimal?</returns>
        public ApiResponse< decimal? > BalanceLicGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BalanceLicGet");

            var localVarPath = "/balance.lic";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BalanceLicGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<decimal?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (decimal?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(decimal?)));
            
        }

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий Возвращает текущий баланс аккаунта лицензий
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of decimal?</returns>
        public async System.Threading.Tasks.Task<decimal?> BalanceLicGetAsync (string token_)
        {
             ApiResponse<decimal?> localVarResponse = await BalanceLicGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий Возвращает текущий баланс аккаунта лицензий
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (decimal?)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<decimal?>> BalanceLicGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BalanceLicGet");

            var localVarPath = "/balance.lic";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BalanceLicGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<decimal?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (decimal?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(decimal?)));
            
        }

        /// <summary>
        /// Информация по дебету аккаунта Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse200&gt;</returns>
        public List<InlineResponse200> BillingDebtGet (string token_)
        {
             ApiResponse<List<InlineResponse200>> localVarResponse = BillingDebtGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Информация по дебету аккаунта Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse200&gt;</returns>
        public ApiResponse< List<InlineResponse200> > BillingDebtGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingDebtGet");

            var localVarPath = "/billing/debt";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingDebtGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse200>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse200>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse200>)));
            
        }

        /// <summary>
        /// Информация по дебету аккаунта Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse200&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse200>> BillingDebtGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse200>> localVarResponse = await BillingDebtGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Информация по дебету аккаунта Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse200&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse200>>> BillingDebtGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingDebtGet");

            var localVarPath = "/billing/debt";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingDebtGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse200>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse200>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse200>)));
            
        }

        /// <summary>
        /// Информация об аккаунте Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2001&gt;</returns>
        public List<InlineResponse2001> BillingInfoGet (string token_)
        {
             ApiResponse<List<InlineResponse2001>> localVarResponse = BillingInfoGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Информация об аккаунте Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2001&gt;</returns>
        public ApiResponse< List<InlineResponse2001> > BillingInfoGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingInfoGet");

            var localVarPath = "/billing/info";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingInfoGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2001>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2001>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2001>)));
            
        }

        /// <summary>
        /// Информация об аккаунте Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2001&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2001>> BillingInfoGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2001>> localVarResponse = await BillingInfoGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Информация об аккаунте Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2001&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2001>>> BillingInfoGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingInfoGet");

            var localVarPath = "/billing/info";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingInfoGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2001>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2001>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2001>)));
            
        }

        /// <summary>
        /// Получить ограничения аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>_</returns>
        public _ BillingLimitsGet (string token_)
        {
             ApiResponse<_> localVarResponse = BillingLimitsGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Получить ограничения аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of _</returns>
        public ApiResponse< _ > BillingLimitsGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingLimitsGet");

            var localVarPath = "/billing/limits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingLimitsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<_>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (_) Configuration.ApiClient.Deserialize(localVarResponse, typeof(_)));
            
        }

        /// <summary>
        /// Получить ограничения аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of _</returns>
        public async System.Threading.Tasks.Task<_> BillingLimitsGetAsync (string token_)
        {
             ApiResponse<_> localVarResponse = await BillingLimitsGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Получить ограничения аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (_)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<_>> BillingLimitsGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->BillingLimitsGet");

            var localVarPath = "/billing/limits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BillingLimitsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<_>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (_) Configuration.ApiClient.Deserialize(localVarResponse, typeof(_)));
            
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2004&gt;</returns>
        public List<InlineResponse2004> DnsProlongListGet (string token_)
        {
             ApiResponse<List<InlineResponse2004>> localVarResponse = DnsProlongListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2004&gt;</returns>
        public ApiResponse< List<InlineResponse2004> > DnsProlongListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->DnsProlongListGet");

            var localVarPath = "/dns/prolong/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsProlongListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2004>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2004>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2004>)));
            
        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2004&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2004>> DnsProlongListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2004>> localVarResponse = await DnsProlongListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Информация по продлению доменов 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2004&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2004>>> DnsProlongListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->DnsProlongListGet");

            var localVarPath = "/dns/prolong/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DnsProlongListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2004>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2004>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2004>)));
            
        }

        /// <summary>
        /// Создание почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>string</returns>
        public string EmailAddGet (string token_, string addEmail)
        {
             ApiResponse<string> localVarResponse = EmailAddGetWithHttpInfo(token_, addEmail);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Создание почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > EmailAddGetWithHttpInfo (string token_, string addEmail)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAddGet");
            // verify the required parameter 'addEmail' is set
            if (addEmail == null)
                throw new ApiException(400, "Missing required parameter 'addEmail' when calling DefaultApi->EmailAddGet");

            var localVarPath = "/email/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (addEmail != null) localVarQueryParams.Add("add_email", Configuration.ApiClient.ParameterToString(addEmail)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Создание почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> EmailAddGetAsync (string token_, string addEmail)
        {
             ApiResponse<string> localVarResponse = await EmailAddGetAsyncWithHttpInfo(token_, addEmail);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Создание почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> EmailAddGetAsyncWithHttpInfo (string token_, string addEmail)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAddGet");
            // verify the required parameter 'addEmail' is set
            if (addEmail == null)
                throw new ApiException(400, "Missing required parameter 'addEmail' when calling DefaultApi->EmailAddGet");

            var localVarPath = "/email/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (addEmail != null) localVarQueryParams.Add("add_email", Configuration.ApiClient.ParameterToString(addEmail)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>string</returns>
        public string EmailAliasDeleteGet (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = EmailAliasDeleteGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > EmailAliasDeleteGetWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAliasDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->EmailAliasDeleteGet");

            var localVarPath = "/email/alias/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAliasDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> EmailAliasDeleteGetAsync (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = await EmailAliasDeleteGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Удаление псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> EmailAliasDeleteGetAsyncWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAliasDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->EmailAliasDeleteGet");

            var localVarPath = "/email/alias/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAliasDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2005&gt;</returns>
        public List<InlineResponse2005> EmailAliasListGet (string token_)
        {
             ApiResponse<List<InlineResponse2005>> localVarResponse = EmailAliasListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2005&gt;</returns>
        public ApiResponse< List<InlineResponse2005> > EmailAliasListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAliasListGet");

            var localVarPath = "/email/alias/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAliasListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2005>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2005>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2005>)));
            
        }

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2005&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2005>> EmailAliasListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2005>> localVarResponse = await EmailAliasListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Получить список псевдонимов почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2005&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2005>>> EmailAliasListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailAliasListGet");

            var localVarPath = "/email/alias/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailAliasListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2005>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2005>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2005>)));
            
        }

        /// <summary>
        /// Удаление почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>string</returns>
        public string EmailDeleteGet (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = EmailDeleteGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Удаление почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > EmailDeleteGetWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->EmailDeleteGet");

            var localVarPath = "/email/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> EmailDeleteGetAsync (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = await EmailDeleteGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Удаление почтового ящика 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> EmailDeleteGetAsyncWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->EmailDeleteGet");

            var localVarPath = "/email/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Получить список почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse2006&gt;</returns>
        public List<InlineResponse2006> EmailListGet (string token_)
        {
             ApiResponse<List<InlineResponse2006>> localVarResponse = EmailListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Получить список почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse2006&gt;</returns>
        public ApiResponse< List<InlineResponse2006> > EmailListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailListGet");

            var localVarPath = "/email/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2006>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2006>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2006>)));
            
        }

        /// <summary>
        /// Получить список почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse2006&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse2006>> EmailListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse2006>> localVarResponse = await EmailListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Получить список почтовых ящиков 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse2006&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse2006>>> EmailListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->EmailListGet");

            var localVarPath = "/email/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmailListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse2006>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse2006>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse2006>)));
            
        }

        /// <summary>
        /// Идентификатор последнего уведомления в аудите 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>int?</returns>
        public int? UpdatesLastGet (string token_)
        {
             ApiResponse<int?> localVarResponse = UpdatesLastGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Идентификатор последнего уведомления в аудите 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of int?</returns>
        public ApiResponse< int? > UpdatesLastGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->UpdatesLastGet");

            var localVarPath = "/updates/last";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdatesLastGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<int?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (int?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(int?)));
            
        }

        /// <summary>
        /// Идентификатор последнего уведомления в аудите 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of int?</returns>
        public async System.Threading.Tasks.Task<int?> UpdatesLastGetAsync (string token_)
        {
             ApiResponse<int?> localVarResponse = await UpdatesLastGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Идентификатор последнего уведомления в аудите 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (int?)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<int?>> UpdatesLastGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->UpdatesLastGet");

            var localVarPath = "/updates/last";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdatesLastGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<int?>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (int?) Configuration.ApiClient.Deserialize(localVarResponse, typeof(int?)));
            
        }

        /// <summary>
        /// Список записей аудита 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>List&lt;InlineResponse20010&gt;</returns>
        public List<InlineResponse20010> UpdatesListGet (string token_, int? key_)
        {
             ApiResponse<List<InlineResponse20010>> localVarResponse = UpdatesListGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Список записей аудита 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20010&gt;</returns>
        public ApiResponse< List<InlineResponse20010> > UpdatesListGetWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->UpdatesListGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->UpdatesListGet");

            var localVarPath = "/updates/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdatesListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20010>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20010>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20010>)));
            
        }

        /// <summary>
        /// Список записей аудита 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>Task of List&lt;InlineResponse20010&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse20010>> UpdatesListGetAsync (string token_, int? key_)
        {
             ApiResponse<List<InlineResponse20010>> localVarResponse = await UpdatesListGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Список записей аудита 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20010&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20010>>> UpdatesListGetAsyncWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->UpdatesListGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->UpdatesListGet");

            var localVarPath = "/updates/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdatesListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20010>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20010>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20010>)));
            
        }

        /// <summary>
        /// Удаление сайта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>string</returns>
        public string WebsiteDeleteGet (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = WebsiteDeleteGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Удаление сайта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > WebsiteDeleteGetWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->WebsiteDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->WebsiteDeleteGet");

            var localVarPath = "/website/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebsiteDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление сайта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> WebsiteDeleteGetAsync (string token_, string key_)
        {
             ApiResponse<string> localVarResponse = await WebsiteDeleteGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Удаление сайта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> WebsiteDeleteGetAsyncWithHttpInfo (string token_, string key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->WebsiteDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling DefaultApi->WebsiteDeleteGet");

            var localVarPath = "/website/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebsiteDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Список сайтов аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse20014&gt;</returns>
        public List<InlineResponse20014> WebsiteListGet (string token_)
        {
             ApiResponse<List<InlineResponse20014>> localVarResponse = WebsiteListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Список сайтов аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20014&gt;</returns>
        public ApiResponse< List<InlineResponse20014> > WebsiteListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->WebsiteListGet");

            var localVarPath = "/website/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebsiteListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20014>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20014>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20014>)));
            
        }

        /// <summary>
        /// Список сайтов аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse20014&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse20014>> WebsiteListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse20014>> localVarResponse = await WebsiteListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Список сайтов аккаунта 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20014&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20014>>> WebsiteListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling DefaultApi->WebsiteListGet");

            var localVarPath = "/website/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("WebsiteListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20014>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20014>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20014>)));
            
        }

    }
}
