/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IVDSHyperVOpenVZApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Изменение параметров VDS
        /// </summary>
        /// <remarks>
        /// Изменение параметров уже существующего VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>string</returns>
        string VdsCreateGet (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null);

        /// <summary>
        /// Изменение параметров VDS
        /// </summary>
        /// <remarks>
        /// Изменение параметров уже существующего VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsCreateGetWithHttpInfo (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null);
        /// <summary>
        /// Удаление VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для удаления VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>string</returns>
        string VdsDeleteGet (string token_, int? key_, bool? forceCritical = null);

        /// <summary>
        /// Удаление VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для удаления VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsDeleteGetWithHttpInfo (string token_, int? key_, bool? forceCritical = null);
        /// <summary>
        /// Добавление IP на VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>string</returns>
        string VdsIpAddGet (string token_, int? key_);

        /// <summary>
        /// Добавление IP на VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsIpAddGetWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Удаление IP с VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет отвязать IP адрес от VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>string</returns>
        string VdsIpDeleteGet (string token_, int? key_, string delIp);

        /// <summary>
        /// Удаление IP с VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет отвязать IP адрес от VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsIpDeleteGetWithHttpInfo (string token_, int? key_, string delIp);
        /// <summary>
        /// Список IP-адресов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Список IP-адресов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>List&lt;InlineResponse20011&gt;</returns>
        List<InlineResponse20011> VdsIpListGet (string token_, int? key_ = null);

        /// <summary>
        /// Список IP-адресов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Список IP-адресов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20011&gt;</returns>
        ApiResponse<List<InlineResponse20011>> VdsIpListGetWithHttpInfo (string token_, int? key_ = null);
        /// <summary>
        /// Список виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>List&lt;InlineResponse20012&gt;</returns>
        List<InlineResponse20012> VdsListGet (string token_, int? key_ = null);

        /// <summary>
        /// Список виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20012&gt;</returns>
        ApiResponse<List<InlineResponse20012>> VdsListGetWithHttpInfo (string token_, int? key_ = null);
        /// <summary>
        /// Перезагрузка VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для перезагрузки VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>string</returns>
        string VdsRebootGet (string token_, int? key_);

        /// <summary>
        /// Перезагрузка VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для перезагрузки VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsRebootGetWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Список шаблонов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список шаблонов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse20013&gt;</returns>
        List<InlineResponse20013> VdsTemplatesListGet (string token_);

        /// <summary>
        /// Список шаблонов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список шаблонов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20013&gt;</returns>
        ApiResponse<List<InlineResponse20013>> VdsTemplatesListGetWithHttpInfo (string token_);
        /// <summary>
        /// Создание VDS
        /// </summary>
        /// <remarks>
        /// Создание новых VDS с произвольными характеристиками
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>string</returns>
        string VdsUpdateGet (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null);

        /// <summary>
        /// Создание VDS
        /// </summary>
        /// <remarks>
        /// Создание новых VDS с произвольными характеристиками
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> VdsUpdateGetWithHttpInfo (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Изменение параметров VDS
        /// </summary>
        /// <remarks>
        /// Изменение параметров уже существующего VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsCreateGetAsync (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null);

        /// <summary>
        /// Изменение параметров VDS
        /// </summary>
        /// <remarks>
        /// Изменение параметров уже существующего VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsCreateGetAsyncWithHttpInfo (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null);
        /// <summary>
        /// Удаление VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для удаления VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsDeleteGetAsync (string token_, int? key_, bool? forceCritical = null);

        /// <summary>
        /// Удаление VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для удаления VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsDeleteGetAsyncWithHttpInfo (string token_, int? key_, bool? forceCritical = null);
        /// <summary>
        /// Добавление IP на VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsIpAddGetAsync (string token_, int? key_);

        /// <summary>
        /// Добавление IP на VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsIpAddGetAsyncWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Удаление IP с VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет отвязать IP адрес от VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsIpDeleteGetAsync (string token_, int? key_, string delIp);

        /// <summary>
        /// Удаление IP с VDS
        /// </summary>
        /// <remarks>
        /// Этот вызов позволяет отвязать IP адрес от VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsIpDeleteGetAsyncWithHttpInfo (string token_, int? key_, string delIp);
        /// <summary>
        /// Список IP-адресов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Список IP-адресов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>Task of List&lt;InlineResponse20011&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse20011>> VdsIpListGetAsync (string token_, int? key_ = null);

        /// <summary>
        /// Список IP-адресов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Список IP-адресов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20011&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20011>>> VdsIpListGetAsyncWithHttpInfo (string token_, int? key_ = null);
        /// <summary>
        /// Список виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>Task of List&lt;InlineResponse20012&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse20012>> VdsListGetAsync (string token_, int? key_ = null);

        /// <summary>
        /// Список виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20012&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20012>>> VdsListGetAsyncWithHttpInfo (string token_, int? key_ = null);
        /// <summary>
        /// Перезагрузка VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для перезагрузки VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsRebootGetAsync (string token_, int? key_);

        /// <summary>
        /// Перезагрузка VDS
        /// </summary>
        /// <remarks>
        /// Предоставляет функционал для перезагрузки VDS
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsRebootGetAsyncWithHttpInfo (string token_, int? key_);
        /// <summary>
        /// Список шаблонов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список шаблонов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse20013&gt;</returns>
        System.Threading.Tasks.Task<List<InlineResponse20013>> VdsTemplatesListGetAsync (string token_);

        /// <summary>
        /// Список шаблонов виртуальных серверов
        /// </summary>
        /// <remarks>
        /// Позволяет получить список шаблонов виртуальных серверов
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20013&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20013>>> VdsTemplatesListGetAsyncWithHttpInfo (string token_);
        /// <summary>
        /// Создание VDS
        /// </summary>
        /// <remarks>
        /// Создание новых VDS с произвольными характеристиками
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> VdsUpdateGetAsync (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null);

        /// <summary>
        /// Создание VDS
        /// </summary>
        /// <remarks>
        /// Создание новых VDS с произвольными характеристиками
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> VdsUpdateGetAsyncWithHttpInfo (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class VDSHyperVOpenVZApi : IVDSHyperVOpenVZApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="VDSHyperVOpenVZApi"/> class.
        /// </summary>
        /// <returns></returns>
        public VDSHyperVOpenVZApi(String basePath)
        {
            this.Configuration = new Configuration(new ApiClient(basePath));

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="VDSHyperVOpenVZApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public VDSHyperVOpenVZApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;

            // ensure API client has configuration ready
            if (Configuration.ApiClient.Configuration == null)
            {
                this.Configuration.ApiClient.Configuration = this.Configuration;
            }
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public Dictionary<String, String> DefaultHeader()
        {
            return this.Configuration.DefaultHeader;
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Изменение параметров VDS Изменение параметров уже существующего VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>string</returns>
        public string VdsCreateGet (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null)
        {
             ApiResponse<string> localVarResponse = VdsCreateGetWithHttpInfo(token_, type, crHvmem, crHvdsk, crHvcpu, template, forceMemo, hv1gbPanelVersion, panelInstall, crSsd1, crHvAllSystem);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Изменение параметров VDS Изменение параметров уже существующего VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsCreateGetWithHttpInfo (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsCreateGet");

            var localVarPath = "/vds/create";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (type != null) localVarQueryParams.Add("type", Configuration.ApiClient.ParameterToString(type)); // query parameter
            if (crHvmem != null) localVarQueryParams.Add("cr_hvmem", Configuration.ApiClient.ParameterToString(crHvmem)); // query parameter
            if (crHvdsk != null) localVarQueryParams.Add("cr_hvdsk", Configuration.ApiClient.ParameterToString(crHvdsk)); // query parameter
            if (crHvcpu != null) localVarQueryParams.Add("cr_hvcpu", Configuration.ApiClient.ParameterToString(crHvcpu)); // query parameter
            if (template != null) localVarQueryParams.Add("template", Configuration.ApiClient.ParameterToString(template)); // query parameter
            if (forceMemo != null) localVarQueryParams.Add("force_memo", Configuration.ApiClient.ParameterToString(forceMemo)); // query parameter
            if (hv1gbPanelVersion != null) localVarQueryParams.Add("hv_1gb_panel_version", Configuration.ApiClient.ParameterToString(hv1gbPanelVersion)); // query parameter
            if (panelInstall != null) localVarQueryParams.Add("panel_install", Configuration.ApiClient.ParameterToString(panelInstall)); // query parameter
            if (crSsd1 != null) localVarQueryParams.Add("cr_ssd1", Configuration.ApiClient.ParameterToString(crSsd1)); // query parameter
            if (crHvAllSystem != null) localVarQueryParams.Add("cr_hv_all_system", Configuration.ApiClient.ParameterToString(crHvAllSystem)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsCreateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Изменение параметров VDS Изменение параметров уже существующего VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsCreateGetAsync (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null)
        {
             ApiResponse<string> localVarResponse = await VdsCreateGetAsyncWithHttpInfo(token_, type, crHvmem, crHvdsk, crHvcpu, template, forceMemo, hv1gbPanelVersion, panelInstall, crSsd1, crHvAllSystem);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Изменение параметров VDS Изменение параметров уже существующего VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)</param>
        /// <param name="forceMemo"> (optional)</param>
        /// <param name="hv1gbPanelVersion"> (optional)</param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS (optional)</param>
        /// <param name="crSsd1">Создать всю систему на SSD (optional)</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsCreateGetAsyncWithHttpInfo (string token_, string type = null, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null, string template = null, string forceMemo = null, string hv1gbPanelVersion = null, bool? panelInstall = null, bool? crSsd1 = null, bool? crHvAllSystem = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsCreateGet");

            var localVarPath = "/vds/create";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (type != null) localVarQueryParams.Add("type", Configuration.ApiClient.ParameterToString(type)); // query parameter
            if (crHvmem != null) localVarQueryParams.Add("cr_hvmem", Configuration.ApiClient.ParameterToString(crHvmem)); // query parameter
            if (crHvdsk != null) localVarQueryParams.Add("cr_hvdsk", Configuration.ApiClient.ParameterToString(crHvdsk)); // query parameter
            if (crHvcpu != null) localVarQueryParams.Add("cr_hvcpu", Configuration.ApiClient.ParameterToString(crHvcpu)); // query parameter
            if (template != null) localVarQueryParams.Add("template", Configuration.ApiClient.ParameterToString(template)); // query parameter
            if (forceMemo != null) localVarQueryParams.Add("force_memo", Configuration.ApiClient.ParameterToString(forceMemo)); // query parameter
            if (hv1gbPanelVersion != null) localVarQueryParams.Add("hv_1gb_panel_version", Configuration.ApiClient.ParameterToString(hv1gbPanelVersion)); // query parameter
            if (panelInstall != null) localVarQueryParams.Add("panel_install", Configuration.ApiClient.ParameterToString(panelInstall)); // query parameter
            if (crSsd1 != null) localVarQueryParams.Add("cr_ssd1", Configuration.ApiClient.ParameterToString(crSsd1)); // query parameter
            if (crHvAllSystem != null) localVarQueryParams.Add("cr_hv_all_system", Configuration.ApiClient.ParameterToString(crHvAllSystem)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsCreateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление VDS Предоставляет функционал для удаления VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>string</returns>
        public string VdsDeleteGet (string token_, int? key_, bool? forceCritical = null)
        {
             ApiResponse<string> localVarResponse = VdsDeleteGetWithHttpInfo(token_, key_, forceCritical);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Удаление VDS Предоставляет функционал для удаления VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsDeleteGetWithHttpInfo (string token_, int? key_, bool? forceCritical = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsDeleteGet");

            var localVarPath = "/vds/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (forceCritical != null) localVarQueryParams.Add("force_critical", Configuration.ApiClient.ParameterToString(forceCritical)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление VDS Предоставляет функционал для удаления VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsDeleteGetAsync (string token_, int? key_, bool? forceCritical = null)
        {
             ApiResponse<string> localVarResponse = await VdsDeleteGetAsyncWithHttpInfo(token_, key_, forceCritical);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Удаление VDS Предоставляет функционал для удаления VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsDeleteGetAsyncWithHttpInfo (string token_, int? key_, bool? forceCritical = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsDeleteGet");

            var localVarPath = "/vds/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (forceCritical != null) localVarQueryParams.Add("force_critical", Configuration.ApiClient.ParameterToString(forceCritical)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Добавление IP на VDS Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>string</returns>
        public string VdsIpAddGet (string token_, int? key_)
        {
             ApiResponse<string> localVarResponse = VdsIpAddGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Добавление IP на VDS Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsIpAddGetWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpAddGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpAddGet");

            var localVarPath = "/vds/ip/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Добавление IP на VDS Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsIpAddGetAsync (string token_, int? key_)
        {
             ApiResponse<string> localVarResponse = await VdsIpAddGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Добавление IP на VDS Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsIpAddGetAsyncWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpAddGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpAddGet");

            var localVarPath = "/vds/ip/add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление IP с VDS Этот вызов позволяет отвязать IP адрес от VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>string</returns>
        public string VdsIpDeleteGet (string token_, int? key_, string delIp)
        {
             ApiResponse<string> localVarResponse = VdsIpDeleteGetWithHttpInfo(token_, key_, delIp);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Удаление IP с VDS Этот вызов позволяет отвязать IP адрес от VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsIpDeleteGetWithHttpInfo (string token_, int? key_, string delIp)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");
            // verify the required parameter 'delIp' is set
            if (delIp == null)
                throw new ApiException(400, "Missing required parameter 'delIp' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");

            var localVarPath = "/vds/ip/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (delIp != null) localVarQueryParams.Add("del_ip", Configuration.ApiClient.ParameterToString(delIp)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Удаление IP с VDS Этот вызов позволяет отвязать IP адрес от VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsIpDeleteGetAsync (string token_, int? key_, string delIp)
        {
             ApiResponse<string> localVarResponse = await VdsIpDeleteGetAsyncWithHttpInfo(token_, key_, delIp);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Удаление IP с VDS Этот вызов позволяет отвязать IP адрес от VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsIpDeleteGetAsyncWithHttpInfo (string token_, int? key_, string delIp)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");
            // verify the required parameter 'delIp' is set
            if (delIp == null)
                throw new ApiException(400, "Missing required parameter 'delIp' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet");

            var localVarPath = "/vds/ip/delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (delIp != null) localVarQueryParams.Add("del_ip", Configuration.ApiClient.ParameterToString(delIp)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Список IP-адресов виртуальных серверов Список IP-адресов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>List&lt;InlineResponse20011&gt;</returns>
        public List<InlineResponse20011> VdsIpListGet (string token_, int? key_ = null)
        {
             ApiResponse<List<InlineResponse20011>> localVarResponse = VdsIpListGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Список IP-адресов виртуальных серверов Список IP-адресов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20011&gt;</returns>
        public ApiResponse< List<InlineResponse20011> > VdsIpListGetWithHttpInfo (string token_, int? key_ = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpListGet");

            var localVarPath = "/vds/ip/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20011>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20011>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20011>)));
            
        }

        /// <summary>
        /// Список IP-адресов виртуальных серверов Список IP-адресов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>Task of List&lt;InlineResponse20011&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse20011>> VdsIpListGetAsync (string token_, int? key_ = null)
        {
             ApiResponse<List<InlineResponse20011>> localVarResponse = await VdsIpListGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Список IP-адресов виртуальных серверов Список IP-адресов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20011&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20011>>> VdsIpListGetAsyncWithHttpInfo (string token_, int? key_ = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpListGet");

            var localVarPath = "/vds/ip/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsIpListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20011>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20011>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20011>)));
            
        }

        /// <summary>
        /// Список виртуальных серверов Позволяет получить список виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>List&lt;InlineResponse20012&gt;</returns>
        public List<InlineResponse20012> VdsListGet (string token_, int? key_ = null)
        {
             ApiResponse<List<InlineResponse20012>> localVarResponse = VdsListGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Список виртуальных серверов Позволяет получить список виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20012&gt;</returns>
        public ApiResponse< List<InlineResponse20012> > VdsListGetWithHttpInfo (string token_, int? key_ = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsListGet");

            var localVarPath = "/vds/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20012>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20012>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20012>)));
            
        }

        /// <summary>
        /// Список виртуальных серверов Позволяет получить список виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>Task of List&lt;InlineResponse20012&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse20012>> VdsListGetAsync (string token_, int? key_ = null)
        {
             ApiResponse<List<InlineResponse20012>> localVarResponse = await VdsListGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Список виртуальных серверов Позволяет получить список виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20012&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20012>>> VdsListGetAsyncWithHttpInfo (string token_, int? key_ = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsListGet");

            var localVarPath = "/vds/list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20012>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20012>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20012>)));
            
        }

        /// <summary>
        /// Перезагрузка VDS Предоставляет функционал для перезагрузки VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>string</returns>
        public string VdsRebootGet (string token_, int? key_)
        {
             ApiResponse<string> localVarResponse = VdsRebootGetWithHttpInfo(token_, key_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Перезагрузка VDS Предоставляет функционал для перезагрузки VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsRebootGetWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsRebootGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsRebootGet");

            var localVarPath = "/vds/reboot";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsRebootGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Перезагрузка VDS Предоставляет функционал для перезагрузки VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsRebootGetAsync (string token_, int? key_)
        {
             ApiResponse<string> localVarResponse = await VdsRebootGetAsyncWithHttpInfo(token_, key_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Перезагрузка VDS Предоставляет функционал для перезагрузки VDS
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsRebootGetAsyncWithHttpInfo (string token_, int? key_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsRebootGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsRebootGet");

            var localVarPath = "/vds/reboot";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsRebootGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Список шаблонов виртуальных серверов Позволяет получить список шаблонов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>List&lt;InlineResponse20013&gt;</returns>
        public List<InlineResponse20013> VdsTemplatesListGet (string token_)
        {
             ApiResponse<List<InlineResponse20013>> localVarResponse = VdsTemplatesListGetWithHttpInfo(token_);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Список шаблонов виртуальных серверов Позволяет получить список шаблонов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>ApiResponse of List&lt;InlineResponse20013&gt;</returns>
        public ApiResponse< List<InlineResponse20013> > VdsTemplatesListGetWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsTemplatesListGet");

            var localVarPath = "/vds/templates-list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsTemplatesListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20013>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20013>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20013>)));
            
        }

        /// <summary>
        /// Список шаблонов виртуальных серверов Позволяет получить список шаблонов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of List&lt;InlineResponse20013&gt;</returns>
        public async System.Threading.Tasks.Task<List<InlineResponse20013>> VdsTemplatesListGetAsync (string token_)
        {
             ApiResponse<List<InlineResponse20013>> localVarResponse = await VdsTemplatesListGetAsyncWithHttpInfo(token_);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Список шаблонов виртуальных серверов Позволяет получить список шаблонов виртуальных серверов
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <returns>Task of ApiResponse (List&lt;InlineResponse20013&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<InlineResponse20013>>> VdsTemplatesListGetAsyncWithHttpInfo (string token_)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsTemplatesListGet");

            var localVarPath = "/vds/templates-list";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsTemplatesListGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<InlineResponse20013>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<InlineResponse20013>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<InlineResponse20013>)));
            
        }

        /// <summary>
        /// Создание VDS Создание новых VDS с произвольными характеристиками
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>string</returns>
        public string VdsUpdateGet (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null)
        {
             ApiResponse<string> localVarResponse = VdsUpdateGetWithHttpInfo(token_, key_, crHvmem, crHvdsk, crHvcpu);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Создание VDS Создание новых VDS с произвольными характеристиками
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > VdsUpdateGetWithHttpInfo (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsUpdateGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsUpdateGet");

            var localVarPath = "/vds/update";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (crHvmem != null) localVarQueryParams.Add("cr_hvmem", Configuration.ApiClient.ParameterToString(crHvmem)); // query parameter
            if (crHvdsk != null) localVarQueryParams.Add("cr_hvdsk", Configuration.ApiClient.ParameterToString(crHvdsk)); // query parameter
            if (crHvcpu != null) localVarQueryParams.Add("cr_hvcpu", Configuration.ApiClient.ParameterToString(crHvcpu)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsUpdateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

        /// <summary>
        /// Создание VDS Создание новых VDS с произвольными характеристиками
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> VdsUpdateGetAsync (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null)
        {
             ApiResponse<string> localVarResponse = await VdsUpdateGetAsyncWithHttpInfo(token_, key_, crHvmem, crHvdsk, crHvcpu);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Создание VDS Создание новых VDS с произвольными характеристиками
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30 (optional)</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2 (optional)</param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> VdsUpdateGetAsyncWithHttpInfo (string token_, int? key_, int? crHvmem = null, int? crHvdsk = null, int? crHvcpu = null)
        {
            // verify the required parameter 'token_' is set
            if (token_ == null)
                throw new ApiException(400, "Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsUpdateGet");
            // verify the required parameter 'key_' is set
            if (key_ == null)
                throw new ApiException(400, "Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsUpdateGet");

            var localVarPath = "/vds/update";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new Dictionary<String, String>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // set "format" to json by default
            // e.g. /pet/{petId}.{format} becomes /pet/{petId}.json
            localVarPathParams.Add("format", "json");
            if (token_ != null) localVarQueryParams.Add("_token_", Configuration.ApiClient.ParameterToString(token_)); // query parameter
            if (key_ != null) localVarQueryParams.Add("_key_", Configuration.ApiClient.ParameterToString(key_)); // query parameter
            if (crHvmem != null) localVarQueryParams.Add("cr_hvmem", Configuration.ApiClient.ParameterToString(crHvmem)); // query parameter
            if (crHvdsk != null) localVarQueryParams.Add("cr_hvdsk", Configuration.ApiClient.ParameterToString(crHvdsk)); // query parameter
            if (crHvcpu != null) localVarQueryParams.Add("cr_hvcpu", Configuration.ApiClient.ParameterToString(crHvcpu)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VdsUpdateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
            
        }

    }
}
