/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// InlineResponse200
    /// </summary>
    [DataContract]
    public partial class InlineResponse200 :  IEquatable<InlineResponse200>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse200" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected InlineResponse200() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse200" /> class.
        /// </summary>
        /// <param name="NegativeBalanceDays">Планируемое количество дней до наступления негативного баланса (required).</param>
        /// <param name="NegativeBalanceDaysLic">Планируемое количество дней до наступления негативного баланса по аккаунту лицензий (required).</param>
        /// <param name="LastMonthDebtSum"> (required).</param>
        /// <param name="LastMonthDebtSum2"> (required).</param>
        /// <param name="BlockDate">Дата блокировки аккаунта (required).</param>
        public InlineResponse200(int? NegativeBalanceDays = null, int? NegativeBalanceDaysLic = null, decimal? LastMonthDebtSum = null, decimal? LastMonthDebtSum2 = null, string BlockDate = null)
        {
            // to ensure "NegativeBalanceDays" is required (not null)
            if (NegativeBalanceDays == null)
            {
                throw new InvalidDataException("NegativeBalanceDays is a required property for InlineResponse200 and cannot be null");
            }
            else
            {
                this.NegativeBalanceDays = NegativeBalanceDays;
            }
            // to ensure "NegativeBalanceDaysLic" is required (not null)
            if (NegativeBalanceDaysLic == null)
            {
                throw new InvalidDataException("NegativeBalanceDaysLic is a required property for InlineResponse200 and cannot be null");
            }
            else
            {
                this.NegativeBalanceDaysLic = NegativeBalanceDaysLic;
            }
            // to ensure "LastMonthDebtSum" is required (not null)
            if (LastMonthDebtSum == null)
            {
                throw new InvalidDataException("LastMonthDebtSum is a required property for InlineResponse200 and cannot be null");
            }
            else
            {
                this.LastMonthDebtSum = LastMonthDebtSum;
            }
            // to ensure "LastMonthDebtSum2" is required (not null)
            if (LastMonthDebtSum2 == null)
            {
                throw new InvalidDataException("LastMonthDebtSum2 is a required property for InlineResponse200 and cannot be null");
            }
            else
            {
                this.LastMonthDebtSum2 = LastMonthDebtSum2;
            }
            // to ensure "BlockDate" is required (not null)
            if (BlockDate == null)
            {
                throw new InvalidDataException("BlockDate is a required property for InlineResponse200 and cannot be null");
            }
            else
            {
                this.BlockDate = BlockDate;
            }
        }
        
        /// <summary>
        /// Планируемое количество дней до наступления негативного баланса
        /// </summary>
        /// <value>Планируемое количество дней до наступления негативного баланса</value>
        [DataMember(Name="negative_balance_days", EmitDefaultValue=false)]
        public int? NegativeBalanceDays { get; set; }
        /// <summary>
        /// Планируемое количество дней до наступления негативного баланса по аккаунту лицензий
        /// </summary>
        /// <value>Планируемое количество дней до наступления негативного баланса по аккаунту лицензий</value>
        [DataMember(Name="negative_balance_days_lic", EmitDefaultValue=false)]
        public int? NegativeBalanceDaysLic { get; set; }
        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        [DataMember(Name="last_month_debt_sum", EmitDefaultValue=false)]
        public decimal? LastMonthDebtSum { get; set; }
        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        [DataMember(Name="last_month_debt_sum2", EmitDefaultValue=false)]
        public decimal? LastMonthDebtSum2 { get; set; }
        /// <summary>
        /// Дата блокировки аккаунта
        /// </summary>
        /// <value>Дата блокировки аккаунта</value>
        [DataMember(Name="block_date", EmitDefaultValue=false)]
        public string BlockDate { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse200 {\n");
            sb.Append("  NegativeBalanceDays: ").Append(NegativeBalanceDays).Append("\n");
            sb.Append("  NegativeBalanceDaysLic: ").Append(NegativeBalanceDaysLic).Append("\n");
            sb.Append("  LastMonthDebtSum: ").Append(LastMonthDebtSum).Append("\n");
            sb.Append("  LastMonthDebtSum2: ").Append(LastMonthDebtSum2).Append("\n");
            sb.Append("  BlockDate: ").Append(BlockDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as InlineResponse200);
        }

        /// <summary>
        /// Returns true if InlineResponse200 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse200 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse200 other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.NegativeBalanceDays == other.NegativeBalanceDays ||
                    this.NegativeBalanceDays != null &&
                    this.NegativeBalanceDays.Equals(other.NegativeBalanceDays)
                ) && 
                (
                    this.NegativeBalanceDaysLic == other.NegativeBalanceDaysLic ||
                    this.NegativeBalanceDaysLic != null &&
                    this.NegativeBalanceDaysLic.Equals(other.NegativeBalanceDaysLic)
                ) && 
                (
                    this.LastMonthDebtSum == other.LastMonthDebtSum ||
                    this.LastMonthDebtSum != null &&
                    this.LastMonthDebtSum.Equals(other.LastMonthDebtSum)
                ) && 
                (
                    this.LastMonthDebtSum2 == other.LastMonthDebtSum2 ||
                    this.LastMonthDebtSum2 != null &&
                    this.LastMonthDebtSum2.Equals(other.LastMonthDebtSum2)
                ) && 
                (
                    this.BlockDate == other.BlockDate ||
                    this.BlockDate != null &&
                    this.BlockDate.Equals(other.BlockDate)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.NegativeBalanceDays != null)
                    hash = hash * 59 + this.NegativeBalanceDays.GetHashCode();
                if (this.NegativeBalanceDaysLic != null)
                    hash = hash * 59 + this.NegativeBalanceDaysLic.GetHashCode();
                if (this.LastMonthDebtSum != null)
                    hash = hash * 59 + this.LastMonthDebtSum.GetHashCode();
                if (this.LastMonthDebtSum2 != null)
                    hash = hash * 59 + this.LastMonthDebtSum2.GetHashCode();
                if (this.BlockDate != null)
                    hash = hash * 59 + this.BlockDate.GetHashCode();
                return hash;
            }
        }
    }

}
