/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// InlineResponse2003
    /// </summary>
    [DataContract]
    public partial class InlineResponse2003 :  IEquatable<InlineResponse2003>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2003" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected InlineResponse2003() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2003" /> class.
        /// </summary>
        /// <param name="Id">идентификатор домена (required).</param>
        /// <param name="IisId">идентификатор связанной записи IIS (required).</param>
        /// <param name="Online">домен работает, если true (required).</param>
        /// <param name="FullDomainName">полное имя домена (required).</param>
        /// <param name="FullDomainNameLocal"> (required).</param>
        /// <param name="Addr1"> (required).</param>
        /// <param name="Zone">зона домена (required).</param>
        public InlineResponse2003(int? Id = null, int? IisId = null, bool? Online = null, string FullDomainName = null, string FullDomainNameLocal = null, string Addr1 = null, string Zone = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "IisId" is required (not null)
            if (IisId == null)
            {
                throw new InvalidDataException("IisId is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.IisId = IisId;
            }
            // to ensure "Online" is required (not null)
            if (Online == null)
            {
                throw new InvalidDataException("Online is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.Online = Online;
            }
            // to ensure "FullDomainName" is required (not null)
            if (FullDomainName == null)
            {
                throw new InvalidDataException("FullDomainName is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.FullDomainName = FullDomainName;
            }
            // to ensure "FullDomainNameLocal" is required (not null)
            if (FullDomainNameLocal == null)
            {
                throw new InvalidDataException("FullDomainNameLocal is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.FullDomainNameLocal = FullDomainNameLocal;
            }
            // to ensure "Addr1" is required (not null)
            if (Addr1 == null)
            {
                throw new InvalidDataException("Addr1 is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.Addr1 = Addr1;
            }
            // to ensure "Zone" is required (not null)
            if (Zone == null)
            {
                throw new InvalidDataException("Zone is a required property for InlineResponse2003 and cannot be null");
            }
            else
            {
                this.Zone = Zone;
            }
        }
        
        /// <summary>
        /// идентификатор домена
        /// </summary>
        /// <value>идентификатор домена</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int? Id { get; set; }
        /// <summary>
        /// идентификатор связанной записи IIS
        /// </summary>
        /// <value>идентификатор связанной записи IIS</value>
        [DataMember(Name="iis_id", EmitDefaultValue=false)]
        public int? IisId { get; set; }
        /// <summary>
        /// домен работает, если true
        /// </summary>
        /// <value>домен работает, если true</value>
        [DataMember(Name="online", EmitDefaultValue=false)]
        public bool? Online { get; set; }
        /// <summary>
        /// полное имя домена
        /// </summary>
        /// <value>полное имя домена</value>
        [DataMember(Name="full_domain_name", EmitDefaultValue=false)]
        public string FullDomainName { get; set; }
        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        [DataMember(Name="full_domain_name_local", EmitDefaultValue=false)]
        public string FullDomainNameLocal { get; set; }
        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        [DataMember(Name="addr1", EmitDefaultValue=false)]
        public string Addr1 { get; set; }
        /// <summary>
        /// зона домена
        /// </summary>
        /// <value>зона домена</value>
        [DataMember(Name="zone", EmitDefaultValue=false)]
        public string Zone { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2003 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  IisId: ").Append(IisId).Append("\n");
            sb.Append("  Online: ").Append(Online).Append("\n");
            sb.Append("  FullDomainName: ").Append(FullDomainName).Append("\n");
            sb.Append("  FullDomainNameLocal: ").Append(FullDomainNameLocal).Append("\n");
            sb.Append("  Addr1: ").Append(Addr1).Append("\n");
            sb.Append("  Zone: ").Append(Zone).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as InlineResponse2003);
        }

        /// <summary>
        /// Returns true if InlineResponse2003 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2003 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2003 other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.IisId == other.IisId ||
                    this.IisId != null &&
                    this.IisId.Equals(other.IisId)
                ) && 
                (
                    this.Online == other.Online ||
                    this.Online != null &&
                    this.Online.Equals(other.Online)
                ) && 
                (
                    this.FullDomainName == other.FullDomainName ||
                    this.FullDomainName != null &&
                    this.FullDomainName.Equals(other.FullDomainName)
                ) && 
                (
                    this.FullDomainNameLocal == other.FullDomainNameLocal ||
                    this.FullDomainNameLocal != null &&
                    this.FullDomainNameLocal.Equals(other.FullDomainNameLocal)
                ) && 
                (
                    this.Addr1 == other.Addr1 ||
                    this.Addr1 != null &&
                    this.Addr1.Equals(other.Addr1)
                ) && 
                (
                    this.Zone == other.Zone ||
                    this.Zone != null &&
                    this.Zone.Equals(other.Zone)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                if (this.IisId != null)
                    hash = hash * 59 + this.IisId.GetHashCode();
                if (this.Online != null)
                    hash = hash * 59 + this.Online.GetHashCode();
                if (this.FullDomainName != null)
                    hash = hash * 59 + this.FullDomainName.GetHashCode();
                if (this.FullDomainNameLocal != null)
                    hash = hash * 59 + this.FullDomainNameLocal.GetHashCode();
                if (this.Addr1 != null)
                    hash = hash * 59 + this.Addr1.GetHashCode();
                if (this.Zone != null)
                    hash = hash * 59 + this.Zone.GetHashCode();
                return hash;
            }
        }
    }

}
